// Load up the jquery.gettext plugin:
$.gt.load();

var flag = true;
var flag2 = true;
var resultTimeout = null;
var rebootRequiredTimeout = null;
var jTipTimeout = null;
function toggleNavigation() {  //Hides the navigation sidebar and resizes the main content div to fill the empty space
    if(flag2) {
        $('#nav-secondary').slideToggle("slow");
        $('#plugin_header').prepend('<div id="two_breaks"><br /><br /></div>');
        setTimeout(function(){
            $("#content").animate({
                marginLeft: "1em"
            }, 1000 );
        }, 1000);
    } else {
        $('#nav-secondary').slideToggle("slow");
        setTimeout(function(){
            $("#content").animate({
                marginLeft: "16em"
            }, 1000 );
            $('#two_breaks').remove();
        }, 1000);
    }
    (flag2)?flag2=false:flag2=true;
};
function removeSidebar() {
    if(flag) {
        document.getElementById("content").style.margin = "0 25% 0 16em";
    } else {
        document.getElementById("content").style.margin = "0 2em 0 16em";
    }
    (flag)?flag=false:flag=true;
};
function helpToggle(help_id) {
    removeSidebar();
    $('#help').slideToggle();
};
function showResult(message) {
    if (message) {$('#result').html(message);};
    $('#result').show('blind', {}, 1000);
    clearTimeout(resultTimeout);
    resultTimeout = setTimeout(function(){
        $('#result').hide('blind',{}, 1000)
    }, 10000);
};
function rebootRequired() {
    $('#apply-changes').html('<span id="close_this" class="ui-icon ui-icon-closethick" style="float: right; cursor: pointer;" onclick="$(this).parent().hide();clearTimeout(rebootRequiredTimeout);return false;"></span><span class="ui-icon ui-icon-notice ui-icon-left" style="margin-right: .3em;"></span>' + _('You have made changes that require a <a href="/System/Reboot">reboot</a>.'));
    $('#apply-changes').show('blind', {}, 1000);
    rebootRequiredTimeout = setTimeout(function(){
        $('#apply-changes').hide('blind',{}, 1000)
    }, 10000);
};
function reloadTab(accordionObj) {
    // Closes the active accordion (if accordionObj is provided) and reloads the current tab
    if (accordionObj) {
        // There's a bug in jquery-ui that prevents this from working:
        var activeAccordion = accordionObj.accordion('option', 'active');
        // I left it here because it doesn't hurt and when they fix the bug it should start working again =)
        accordionObj.accordion( 'activate', false ); // Close this accordion
        accordionObj.fadeOut('slow');
    };
    setTimeout(function(){ // Wait a second then reload the whole tab
        var selectedTab = $('#tabs').tabs('option', 'selected');
        $('#tabs').tabs('load', selectedTab);
        setTimeout(function(){ // Wait half a second then activate the accordion that was active before the reload
            accordionObj.accordion('option', 'active', activeAccordion); // <-- activeAccordion bug mentioned above
        }, 500);
    }, 1000);
};
$(function() {
    $('#pyci-menu').menu({
        content: $('#pyci-menu-items').html(), // grab content from this page
        // Turned off the flyOut style since it is broken in some browsers
//         flyOut: true,
        positionOpts: {
            posX: 'left',
            posY: 'bottom',
            offsetX: 0,
            offsetY: 0,
            directionH: 'right',
            directionV: 'down',
            detectH: true, // do horizontal collision detection
            detectV: true, // do vertical collision detection
            linkToFront: false
        },
        backLink: false,
//         crumbDefaultText: ' '
        crumbDefaultText: 'Plugins',
        topLinkText: 'Plugins',
        width: 300,
        maxHeight: 300
    });
});
function addField(helpURL, table, field, val, section){
    var output = "";
    if (val==undefined) {
        val = '';
    };
    // This is to ensure that each jTip gets a unique ID (otherwise it gets confused in jquery-ui tabs)
    var randomnumber = Math.floor(Math.random()*1000);
    var valuesURL = helpURL + '?option=' + field + '&section=' + section + '&values=True';
    output = '<tr id="' + field + '_tr"><td style="width: 10em;"><a href="' + helpURL + '?width=475&option=' + field + '&section=' + section + '" id="' + field + '_' + randomnumber + '_jtip" class="jTip" name="Option Help">' + field + '</a></td><td style="width: 15em; overflow: hidden;">'
    $.getJSON(valuesURL, function(values){
        if (!values.empty) {
            var d = new Deferred(); // So these execute in order (and more smoothly)
            output = output + '<select id="' + field + randomnumber + '_options" name="' + field + '" title="' + _("Select an option") + '"><option value="">' + _("Select...") + '</option></select></td><td><span id="remove_option" class="ui-icon ui-icon-left ui-icon-closethick" style="cursor: pointer;" onclick="$(this).parent().parent().remove();return false;"></span></td></tr>';
            //table.append(output);
            d.addCallback($(output).hide().appendTo(table).fadeIn(1000));
            d.addCallback($("#" + field + randomnumber + "_options").addOption(values, false));
            if (val != "") {
                d.addCallback($("#" + field + randomnumber + "_options").selectOptions(val));
            };
            // I disabled the sort because it doesn't do "natural" sorting (i.e. it would sort [1,2,3,9,10,11] into [1,10,11,2,3,9]
            // Instead I've changed most of openwrt.py and various *_options_meta() methods to use ordered dictionaries
            // That way the order of the validation/metadata files is preserved.
//             d.addCallback($("#" + field + randomnumber + "_options").sortOptions());
            // I left that there as a placeholder because I might go and change the selectOptions plugin to do a natural sort later.
            d.addCallback($("#" + field + randomnumber + "_options").selectmenu({
                width: 120,
                menuWidth: 500,
                maxHeight: 300,
                format: optionHelpFormatting
            }));
        } else {
            output = output + '<input type="text" id="' + field + randomnumber+ '" name="' + field + '" size="18" value="' + val + '"></td><td><span id="remove_option" class="ui-icon ui-icon-left ui-icon-closethick" style="cursor: pointer;" onclick="$(this).parent().parent().remove();return false;"></span></td></tr>';
//             table.append(output);
            $(output).hide().appendTo(table).fadeIn(1000);
        }
    });
    jTipReload();
};
function mandatoryField(helpURL, table, field, val, section){
    // This function appends an input label/field to the given 'table' using the given parameters and automatically pre-populates it with 'val'.
    // The given 'field' will be checked using the helpURL to see if it has a limited number of options and if so a selectMenu will be used
    // instead of just a 'text' input.
    // helpURL: The base URL to use when looking up help and possible select menu options for this field (i.e. /Network/interface_options_meta).
    // table: A jQuery object representing the table to append the new input TD.
    // field: The field (option) we're making mandatory (e.g. 'name').
    // val: The value of the field should be pre-set to (if any).
    // section: The section (e.g. 'interface', 'alias', 'route', etc) this option pertains to.
    var output = "";
    if (val==undefined) {
        val = '';
    };
    // This is to ensure that each jTip gets a unique ID (otherwise it gets confused in jquery-ui tabs)
    var randomnumber = Math.floor(Math.random()*1000);
    var valuesURL = helpURL + '?option=' + field + '&section=' + section + '&values=True';
    output = '<tr id="' + field + '_tr"><td style="width: 10em;"><a href="' + helpURL + '?width=475&option=' + field + '&section=' + section + '" id="' + field + '_' + randomnumber + '_jtip" class="jTip" name="Option Help">' + field + '</a></td><td>'
    $.getJSON(valuesURL, function(values){
        if (!values.empty) {
            var d = new Deferred(); // So these execute in order (and more smoothly)
            output = output + '<select id="' + randomnumber + field + '_options" name="' + field + '" title="' + _("Select an option") + '"><option value="">' + _("Select...") + '</option></select></td></tr>';
            d.addCallback($(output).hide().appendTo(table).fadeIn(1000));
            d.addCallback($("#" + randomnumber + field + "_options").addOption(values, false));
            if (val != "") {
                d.addCallback($("#" + randomnumber + field + "_options").selectOptions(val));
            };
//             d.addCallback($("#" + randomnumber + field + "_options").sortOptions());
            d.addCallback($("#" + randomnumber + field + "_options").selectmenu({
                width: 120,
                menuWidth: 500,
                maxHeight: 300,
                format: optionHelpFormatting
            }));
        } else { // The extra TD is there for validation messages
            output = output + '<input type="text" id="' + field + '" name="' + field + '" size="18" value="' + val + '"></td><td></td></tr>';
            $(output).hide().appendTo(table).fadeIn(1000);
        }
    });
};
// addField(helpURL, table, field, val, section)
function onSelectChange(selectedObject, table, helpURL, section){
    // selectedObject: The option that was selected in the options list.
    // table: A jQuery object representing the table to append the new input TD.
    // helpURL: The base URL to use when looking up help for this option (i.e. /Network/interface_options_meta).
    // section: The section (e.g. 'interface', 'alias', 'route', etc) this option pertains to.
    var output = "";
    var option = selectedObject.val();
    var valuesURL = helpURL + '?option=' + option + '&section=' + section + '&values=True';
    // This is to ensure that each jTip gets a unique ID (otherwise it gets confused in jquery-ui tabs)
    var randomnumber = Math.floor(Math.random()*1000);
    if (selectedObject.val() != 0){
        output = '<tr><td style="width: 10em;"><a href="' + helpURL + '?width=475&option=' + option + '&section=' + section + '" id="' + option + '_jtip" class="jTip" name="Option Help">' + option + '</a></td><td>'
        $.getJSON(valuesURL, function(values){
            if (!values.empty) {
                var d = new Deferred(); // So these execute in order (and more smoothly)
                output = output + '<select id="' + randomnumber + option + '_options" name="' + option + '" title="' + _("Select an option") + '"><option value="">' + _("Select...") + '</option></select></td><td><span id="remove_option" class="ui-icon ui-icon-left ui-icon-closethick" style="cursor: pointer;" onclick="$(this).parent().parent().remove();return false;"></span></td></tr>';
                d.addCallback($(output).hide().appendTo(table).fadeIn(1000));
                d.addCallback($("#" + randomnumber + option + "_options").addOption(values, false));
//                 d.addCallback($("#" + randomnumber + option + "_options").sortOptions());
                d.addCallback($("#" + randomnumber + option + "_options").selectmenu({
                    width: 120,
                    menuWidth: 500,
                    maxHeight: 300,
                    format: optionHelpFormatting
                }));
            } else {
                output = output + '<input type="text" id="' + option + '" name="' + option + '" size="18"></td><td id="validation_errors"><span id="remove_option" class="ui-icon ui-icon-left ui-icon-closethick" style="cursor: pointer;" onclick="$(this).parent().parent().remove();return false;"></span></td></tr>';
                $(output).hide().appendTo(table).fadeIn(1000);
            }
        });
    };
    jTipReload();  // Have to re-initialize jTip every time we append a new option--maybe there's a workaround?
}
var optionHelpFormatting = function(text){
    // This function formats text for use with the selectmenu plugin
    // It turns things like this:
    //      "SomeOption - This option does the following neat thing..."
    // Into:
    //      "<span class="ui-selectmenu-item-header">$1</span> <span class="ui-selectmenu-item-content">$1</span>"
    // Note: "ui-selectmenu-item-header" and "ui-selectmenu-item-content" are automatically formatted into two lines in CSS.
    var newText = text;
    //array of find replaces
    var findreps = [
        {find:/^([^\!]+) \- /g, rep: '<span class="ui-selectmenu-item-header">$1</span>'},
        {find:/([^\|><]+)$/g, rep: '<span class="ui-selectmenu-item-content">$1</span>'}
    ];

    for (var i in findreps) {
        newText = newText.replace(findreps[i].find, findreps[i].rep);
    }
    return newText;
};
function resetForm(id) {
    // Resets a form given its 'id' (e.g. '#myform')
    $(id + ' :input').each(function(){
        $(this).val('');
    });
};
function reloadSelectmenu(jqObj) {
    // Destroys and re-creates the selectmenu in 'jqObj' using the standard options
    var d = new Deferred();
    d.addCallback(jqObj.selectmenu('destroy'));
    d.addCallback(jqObj.selectmenu({
        width: 120,
        menuWidth: 500,
        maxHeight: 300,
        format: optionHelpFormatting
    }));
};
function jTipReload() {
    // Re-initializes jTip after a 2-second timeout
    // Also clears any existing jTipTimeout so we don't end up reloading it a hundred times.
    var d = new Deferred();
    d.addCallback(clearTimeout(jTipTimeout));
    d.addCallback(
        jTipTimeout = setTimeout(function() {
            JT_uninit();
            setTimeout(function() {JT_init()}, 500);
        }, 2000)
    );
};
$(document).ready(function(){
    $('#result').hide();
    // This sets the hover states for any element with the fg-button class
    $('.fg-button').hover(
        function(){
            $(this).addClass("ui-state-hover");
        },
        function(){
            $(this).removeClass("ui-state-hover");
        }
    );
    $('#apply-changes').hide();
    $(window).scroll(function() {
        $('#system-messages').animate({top: $(window).scrollTop()+"px"},{queue: false, duration: 350});
    });
});