## -*- coding: utf-8 -*-
<%
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['dhcp']['list_items']
del plugin_dict['validation_dict']['dnsmasq']['list_items']
%>
<div id="accordion">
% for section in plugin_dict['dhcp_conf'].sections:
    <%
    underscored_config = "_".join(section['config'])
    joined_config = " ".join(section['config'])
    %>
    % if 'dnsmasq' in section['config']:
    <h3 id="header_dnsmasq"><a href="#">${_("Global DHCP (dnsmasq) Settings")}</a></h3>
    <div>
    <form id="dhcp_form_dnsmasq" class="dhcp_form_class" method="post" action="/Network/update_dhcp">
        <input type="hidden" name="config" value="${joined_config}">
        <table id="dnsmasq_table" width="98%" align="center">
##        % for key, value in section['options'].items():
##            <tr>
##                <td style="width: 10em;"><a href="/Network/dnsmasq_options_help?width=475&option=${key}" id="dnsmasq_${key}" class="jTip" name="Option Help"><span class="ui-icon ui-icon-left ui-icon-help" style="cursor: pointer; margin-right: .3em;"></span></a>${key}</td>
##                <td><input type="text" id="${key}" name="${key}" size="18" value="${value}"></td><td width="80%"><span id="remove_option" class="ui-icon ui-icon-left ui-icon-closethick" style="cursor: pointer;" onclick="$(this).parent().parent().remove();return false;"></span></td>
##            </tr>
##        % endfor
        </table>
        <table width="98%" align="center">
        <tr id="select_option">
            <td style="width: 10em;"><select id="dnsmasq_options" name="options" title="${_('Select a dnsmasq option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['dnsmasq'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['dnsmasq'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
        </tr>
        </table>
        <p><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></p>
    </form>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#dnsmasq_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#dnsmasq_options").change(function(){
            onSelectChange($("#dnsmasq_options option:selected"), $('#dnsmasq_table'), '/Network/dhcp_interface_options_meta', 'dnsmasq');
        });
        // Add all the current options to the dnsmasq table:
    % for key, value in section['options'].items():
        addField('/Network/dhcp_interface_options_meta', $('#dnsmasq_table'), '${key}', '${value}', 'dnsmasq');
    % endfor
        $('#dhcp_form_dnsmasq').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['dnsmasq'].keys()):
    ## The if/else bits here are necessary because Internet Explorer will crap out of there is a trailing comma (IE is a blight on the Internet!)
            % if index < len(plugin_dict['validation_dict']['dnsmasq'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=dhcp&section=dnsmasq"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=dhcp&section=dnsmasq"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
    % else:
    <h3 id="header_${section['config'][1]}"><a href="#">${section['config'][1]} ${_("DHCP Settings")}</a></h3>
    <div>
    <form id="dhcp_form_${section['config'][1]}" class="dhcp_form_class" method="post" action="/Network/update_dhcp">
        <input type="hidden" name="config" value="${joined_config}">
        <table id="${section['config'][1]}_interface_table" width="98%" align="center">
        </table>
        <table width="98%" align="center">
        <tr><td>${_("Delete this interface from the DHCP configuration")}</td><td><input type="checkbox" name="delete" value="${section['config'][1]}" /></td></tr>
        <tr id="select_option">
            <td style="width: 10em;"><select id="${section['config'][1]}_options" name="options" title="${_('Select an dhcp interface option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['dhcp'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['dhcp'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
        </tr>
        </table>
        <p><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></p>
    </form>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $('#${section['config'][1]}_options').removeOption('interface')
        $("#${section['config'][1]}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${section['config'][1]}_options").change(function(){
            onSelectChange($("#${section['config'][1]}_options option:selected"), $('#${section['config'][1]}_interface_table'), '/Network/dhcp_interface_options_meta', 'dhcp');
        });
        // Add all the current options to the dnsmasq table:
    % for key, value in section['options'].items():
        addField('/Network/dhcp_interface_options_meta', $('#${section['config'][1]}_interface_table'), '${key}', '${value}', 'dhcp');
    % endfor
        $('#dhcp_form_${section['config'][1]}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: { // Add all the validation rules for interface options
        % for index, option in enumerate(plugin_dict['validation_dict']['dhcp'].keys()):
    ## The if/else bits here are necessary because Internet Explorer will crap out of there is a trailing comma (IE is a blight on the Internet!)
            % if index < len(plugin_dict['validation_dict']['dhcp'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=dhcp&section=dhcp"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=dhcp&section=dhcp"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
    % endif
% endfor
</div>
<script type="text/javascript">
$(document).ready(function(){
    $("#accordion").hide();
    $("#accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#accordion").fadeIn('slow');
        $("#accordion").accordion('activate', 0);
    }, 500);
    $('.dhcp_form_class*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {reloadTab($("#accordion"));}, 500);
                    rebootRequired();
                };
            }
        })
    });
    // This just changes the header and the (redundant) 'interface' input to match the value of the interface name if the user changes it
    $("input[name='rename']").blur(function () {
        thisHeaderID = '#header_' + $(this).attr('id');
        newvalue = $(this).attr('value');
        $(thisHeaderID).html('<a href="#">DHCP On ' + newvalue + '</a>');
        thisInterfaceInput = '#' + $(this).attr('id') + '_interface';
        newinput = '<input type="text" id="' + thisInterfaceInput + '" name="interface" size="18" value="' + newvalue + '" />';
        $("input[name='interface']").replaceWith(newinput);
    });
    // TODO:  Figure out why when you change the value of either of these inputs it updates the other fine, but when you change the OTHER one, it won't update anymore
    $("input[name='interface']").blur(function () {
        interfaceSplit = $(this).attr('id').split('_');
        interfaceID = interfaceSplit[0]
        thisHeaderID = '#header_' + interfaceID;
        newvalue = $(this).attr('value');
        $(thisHeaderID).html('<a href="#">DHCP On ' + newvalue + '</a>');
        renameInput = $("#" + interfaceID);
        newinput = '<input type="text" id="' + interfaceID + '" name="rename" size="18" value="' + newvalue + '" />';
        renameInput.replaceWith(newinput);
    });
    jTipReload();
});
</script>
