$(document).ready(function(){
    var eventsMenu = {
        menuStyle: {
            width: '200px'
        },
        bindings: {
            'enable': function(t) {
                $.ajax({
                    type: "POST",
                    dataType: "json",
                    url: "/PyCISettings/update_plugins",
                    data: {plugin: t.id, enable: true},
                    complete: function(data){ // For some reason if I set this to "success" instead of complete this function never gets triggered
                        $('#plugin_management').trigger("reloadGrid");
                    }
                });
            },
            'disable': function(t) {
                $.ajax({
                    type: "POST",
                    dataType: "json",
                    url: "/PyCISettings/update_plugins",
                    data: {plugin: t.id, disable: true},
                    complete: function(data){
                        $('#plugin_management').trigger("reloadGrid");
                    }
                });
            }
        }
    };
    jQuery('#plugin_management').jqGrid({
        url:'/PyCISettings/plugin_management_json',
        datatype: "json",
        colNames:[_('Plugin'), _('Enabled')],
        colModel:[
            {name:'Plugin',index:'Plugin', width: 120},
            {name:'Enabled',index:'Enabled', width: 50},
        ],
        width: 500,
        rowNum:10,
        rowList:[10,20,30],
        multiselect: false,
        toolbar: [true, "top"],
        pager: jQuery('#pplugin_management'),
        sortname: 'Plugin',
        viewrecords: true,
        sortorder: "asc",
        afterInsertRow: function(rowid, rowdata, rowelem) {
            $('#plugin_management #' + rowid).contextMenu('pluginsContextMenu', eventsMenu);
        },
        editurl: "/PyCISettings/update_plugins",
        caption: _("Manage Plugins")
    }).navGrid("#pplugin_management",{edit:false,add:false,del:false},{},{width:350},{});
    ToolbarButtonAdd("#t_plugin_management", {
        title: _("Export this table to a spreadsheet"),
        caption: _("Export to spreadsheet"),
        onClickButton: function() { document.location.href = '/PyCISettings/get_plugins_spreadsheet' }
        });
});