function logoutUser(mac_address) {
    $.ajax({
        type: "POST",
        dataType: "json",
        url: "/Services/coova_chilli_logout_user",
        data: {mac: mac_address},
        success: function(data){
            showResult(repr(data));
            $('#coova_chilli_status').trigger("reloadGrid");
        }
    });
};
$(document).ready(function(){
    var eventsMenu = {
        menuStyle: {
            width: '200px'
        },
        bindings: {
            'authorize': function(t) {
                $('#authorize_user').dialog('open');
                // Set the hidden sessionid input field value
                $('#authorize_user_sessionid').val($('#coova_chilli_status').getRowData(t.id).session_id);
            },
            'logout': function(t) {
                logoutUser($('#coova_chilli_status').getRowData(t.id).mac);
            }
        }
    };
    jQuery('#coova_chilli_status').jqGrid({
        url:'/Services/coova_chilli_status_json',
        datatype: "json",
        colNames:[_('MAC'), _('IP'), _('State'), _('Session ID'), _('Auth'), _('User'), _('Duration'), _('Idle'), _('In'), _('Out'), _('Max Transfer'), _('Swap Octets'), _('% Used Upload'), _('% Used Download'), _('URL')],
        colModel:[
            {name:'mac',index:'mac', width: 150},
            {name:'ip',index:'ip', width: 90},
            {name:'state',index:'state', width: 20},
            {name:'session_id',index:'session_id', width: 40},
            {name:'auth_status',index:'auth_status', width: 40},
            {name:'user',index:'user', width: 90},
            {name:'duration',index:'duration', width: 90},
            {name:'idle',index:'idle', width: 20},
            {name:'in',index:'in', width: 20},
            {name:'out',index:'out', width: 20},
            {name:'max',index:'max', width: 20},
            {name:'swap_octets',index:'swap_octets', width: 20},
            {name:'percent_up',index:'percent_up', width: 90},
            {name:'percent_down',index:'percent_down', width: 90},
            {name:'original_url',index:'original_url', width: 100}
        ],
//         width: 900,
        height: "100%",
        rowNum:20,
        rowList:[20,50,100],
        multiselect: false,
        toolbar: [true, "top"],
        pager: jQuery('#pcoova_chilli_status'),
        sortname: 'mac',
        viewrecords: true,
        sortorder: "asc",
        afterInsertRow: function(rowid, rowdata, rowelem) {
            $('#coova_chilli_status #' + rowid).contextMenu('coovaChilliStatusContextMenu', eventsMenu);
        },
        editurl: "/Services/coova_chilli_status_update",
        caption: _("Init Scripts")
    }).navGrid("#pcoova_chilli_status",{edit:false,add:false,del:true},{},{},{}).navButtonAdd('#pcoova_chilli_status',{
        caption:_("Authorize"), onClickButton: function(t) {
                $('#authorize_user').dialog('open');
                // Set the hidden sessionid input field value
                $('#authorize_user_sessionid').val($('#coova_chilli_status').getRowData($('#coova_chilli_status').getGridParam('selrow')).session_id);
            },
            position:"last",
            buttonimg : 'ui-icon ui-icon-newwin'
        }).navButtonAdd('#pcoova_chilli_status',{
        caption:_("Logout"), onClickButton: function(t) {
                // This grabs the mac address field value from the selected row and submits it to the server
                // ...via the logoutUser() function.
                logoutUser($('#coova_chilli_status').getRowData($('#coova_chilli_status').getGridParam('selrow')).mac)
            },
            position:"last",
            buttonimg : 'ui-icon ui-icon-trash'
        });
    $('#coova_chilli_status').getRowData($('#coova_chilli_status').getGridParam('selrow')).mac;
    ToolbarButtonAdd("#t_coova_chilli_status", {
        title: _("Show or hide visible olumns"),
        caption: _("Show/Hide Columns"),
        onClickButton: function() { jQuery("#coova_chilli_status").setColumns(); }
        });
    ToolbarButtonAdd("#t_coova_chilli_status", {
        title: _("Export this table to a spreadsheet"),
        caption: _("Export to spreadsheet"),
        onClickButton: function() { document.location.href = '/Services/get_coova_chilli_status_spreadsheet' }
        });
    // I'm just guessing (not positive) that these columns aren't as important so I kept them out of the default view
    jQuery("#coova_chilli_status").hideCol("state");
    jQuery("#coova_chilli_status").hideCol("session_id");
    jQuery("#coova_chilli_status").hideCol("in");
    jQuery("#coova_chilli_status").hideCol("out");
    jQuery("#coova_chilli_status").hideCol("max");
    jQuery("#coova_chilli_status").hideCol("swap_octets");
    jQuery("#coova_chilli_status").hideCol("idle");
    $("#authorize_user").dialog({
        autoOpen: false,
        autoResize: true,
        width: 450,
        show: 'slide',
        hide: 'slide',
        title: _('Manually Authorize User'),
        buttons: {
            "Submit": function() { $('#authorize_user_form').submit() },
            "Cancel": function() { $(this).dialog("close") }
        }
    });
    $('#authorize_user_form').ajaxForm({
        target: '#result',
        success: function() {
            $('#authorize_user').dialog("close");
            $('#coova_chilli_status').trigger("reloadGrid");
            showResult();
        }
    });
    $("#authorize_user_form").validate({
        rules: {
            username: {
                required: true
            }
        }
    });
    $('#coovaChilliStatusContextMenu').hide();
});