<style type="text/css">
    #feedback { font-size: 1.4em; }
    #selectable .ui-selected { background: #18486d; color: white; }
    #selectable { list-style-type: none; margin: 0; padding: 1em; }
    #selectable li { margin: 3px; padding: 1px; float: left; width: 8em; font-size: 1.4em; text-align: center; }
    #selectable:hover { cursor:pointer }
</style>
<div id="vtysh_select" style="position: relative; top: 0px; left: 0px; z-index: 10;">
    <p>Please select a Quagga vtysh to connect to:</p>
    <ol id="selectable">
    % for daemon in plugin_dict['daemons']:
        <li class="ui-widget-content" id="${daemon}">${daemon}</li>
    % endfor
        <li class="ui-widget-content" id="custom">Custom</li>
    </ol>
</div>
<div id="console_div" class="terminal"></div>
<form id="quagga_shell_form" method="post" action="/Services/quagga_execute" onsubmit="resetCommandInput('#quagga_shell_form input[name=command]')">
<div id="quagga_execute_div">
    <p><i>Tip: Type "list" to see a list of commands</i></p>
    <table><tr>
        <td><label for="custom_enable">Enable Mode:</label></td>
        <td><input type="checkbox" id="custom_enable" name="enable" size="8" /></td>
        <td><label for="custom_enable_password">Enable Password:</label></td>
        <td><input type="password" id="custom_enable_password" name="enable_password" size="8" value="" /></td>
    </tr></table>
    <input type="text" id="command" name="command" size="50" />
    <button id="submit_button" class="fg-button ui-state-default ui-corner-all" type="submit">Execute</button>
    <button id="cancel" class="fg-button ui-state-default ui-corner-all">Cancel</button>
</div>
<div id="hidden_inputs"></div>
</form>
<div id="custom_vtysh">
    <form id="quagga_shell_custom_form" method="post" action="/Services/quagga_execute" onsubmit="resetCommandInput('#quagga_shell_custom_form input[name=command]')">
    <table><tr>
        <td><label for="host">Host:</label></td><td><input type="text" id="custom_host" name="host" size="8" value="" /></td>
        <td><label for="custom_port">Port:</label></td><td><input type="text" id="custom_port" name="port" size="8" value="" /></td>
        <td><label for="custom_password">Password:</label></td><td><input type="password" id="custom_password" name="password" size="8" value="" /></td>
    </tr>
    <tr>
        <td><label for="host">Enable Mode:</label></td><td><input type="checkbox" id="custom_enable" name="enable" size="8" /></td>
        <td><label for="host">Enable Password:</label></td><td><input type="password" id="custom_enable_password" name="enable_password" size="8" value="" /></td>
    </tr></table><br />
    <input type="text" id="custom_command" name="command" size="50" />
    <button id="submit_button" class="fg-button ui-state-default ui-corner-all" type="submit">Execute</button>
    <button id="custom_cancel" class="fg-button ui-state-default ui-corner-all">Cancel</button>
    </form>
</div>
## Note:  MochiKit is used extensively here for keyboard shortcuts
<script type="text/javascript">
selectedInput = null;
command_history = new Array();
cut_text = null;
history_index = null;
// Assemble a hash table of read-only passwords associated with each Quagga daemon
passwords = {
% for daemon, password in plugin_dict['passwords'].items():
    ${daemon}: "${password}",
% endfor
};
function cancelForm() {
    // Reset everything back to the default values and take us back to the vty selection screen
    if ($('#quagga_execute_div').is(':visible')) {
        $('#quagga_shell_form input[name=command]').val('quit');
        $('#quagga_shell_form').submit();
        $('#quagga_execute_div').fadeOut('slow', function() {
            $('#vtysh_select').fadeIn('slow');
        });
    } else if ($('#custom_vtysh').is(':visible')) {
        $('#quagga_shell_custom_form input[name=command]').val('quit');
        $('#quagga_shell_custom_form').submit();
        $('#custom_vtysh').fadeOut('slow', function() {
            $('#vtysh_select').fadeIn('slow');
        });
    };
    setTimeout(function() {$('#console_div').html('');}, 250);
    resetForm('#quagga_shell_form');
    command_history = new Array();
    cut_text = null;
    history_index = null;
    return false;
};
KeyEvents = {
    emulateSignal: function(e) {
        if ($('#quagga_execute_div').is(':visible')) {
            shellForm = '#quagga_shell_form';
            commandInput = '#quagga_shell_form input[name=command]';
        } else if ($('#custom_vtysh').is(':visible')) {
            shellForm = '#custom_vtysh';
            commandInput = '#quagga_shell_custom_form input[name=command]';
        };
        var key = e.key();
        var modifiers = e.modifier();
        if (modifiers.ctrl && key.string == 'KEY_C') {
            //Emulate bash control-c (which cancels your input)
            $(commandInput).val(''); // Clear the input
        };
        if (modifiers.ctrl && key.string == 'KEY_U') {
            //Emulate bash "cut" (as best we can)
            cut_text = $(commandInput).val();
            $(commandInput).val(''); // Clear the input
        };
        if (modifiers.ctrl && modifiers.shift && key.string == 'KEY_Y') {
            //Emulate bash "paste" (as best we can)
            // TODO:  Figure out how to find the cursor position inside of an <input> element so we can paste the text more precisely
            if (cut_text) {
                pasted = $(commandInput).val() + cut_text
                $(commandInput).val(pasted)
            }
        };
        if (modifiers.ctrl && key.string == 'KEY_D') {
            // Emulate control-D (EOF)
            cancelForm();
        }
        if (key.string == 'KEY_ARROW_UP') {
            if (history_index == null) {
                partial_line = $(commandInput).val();
                history_index = command_history.length-1;
                hist_line = command_history[history_index];
            } else if (history_index == 0) {
                history_index = 0; // Do nothing
            } else if (history_index == command_history.length) {
                partial_line = $(commandInput).val();
                history_index = command_history.length-1;
                hist_line = command_history[history_index];
            } else {
                history_index = history_index - 1;
                hist_line = command_history[history_index];
            };
            $(commandInput).val(hist_line);
        };
        if (key.string == 'KEY_ARROW_DOWN') {
            history_index = history_index + 1;
            if (history_index < command_history.length) {
                hist_line = command_history[history_index];
                $(commandInput).val(hist_line);
            } else if (history_index == command_history.length) {
                $(commandInput).val(partial_line);
            } else if (history_index > command_history.length) {
                history_index = history_index - 1;
            };
        };
    }
};
connect(document, 'onkeydown', function(e) {
    if ($('#quagga_execute_div').is(':visible')) {
        shellForm = '#quagga_shell_form';
        commandInput = '#quagga_shell_form input[name=command]';
    } else if ($('#custom_vtysh').is(':visible')) {
        shellForm = '#custom_vtysh';
        commandInput = '#quagga_shell_custom_form input[name=command]';
    };
    var key = e.key();
    var modifiers = e.modifier();
    if (modifiers.ctrl) { // Only preventDefault() if the control key is held
        if (selectedInput.id == $(commandInput).attr('id')) { // Only if the command input element has focus
            e.preventDefault();
        }
    };
    if (selectedInput.id == $(commandInput).attr('id')) { // Only if the command input element has focus
        KeyEvents.emulateSignal(e);
    };
});
function resetCommandInput(commandInput) {
    setTimeout(function() {
        command_history.push($(commandInput).val());
        $(commandInput).val('');
        $(commandInput).focus();
    }, 250);
};
$('#cancel').click(function() {cancelForm()});
$('#custom_cancel').click(function() {cancelForm()});
$(document).ready(function(){
    $('input, textarea, select').focus(function() {
        selectedInput = this; // Used for detecting focus later
    });
    $('input, textarea, select').blur(function() {
        selectedInput = {id: ' '}; // The equivalent of selecting nothing
    });
    $('#custom_vtysh').hide();
    $('#quagga_execute_div').hide();
    $("#selectable").selectable({
        stop: function(event, ui){
            var result = $("#select-result").empty();
            $('#hidden_inputs').html(''); // Reset everything
            $(".ui-selected", this).each(function(){
                if (this.id != 'custom') {
                    $('#vtysh_select').fadeOut('slow', function() {
                        $('#quagga_execute_div').fadeIn('slow')
                    });
                    $('#hidden_inputs').append('<input type="hidden" id="host" name="host" value="127.0.0.1" />');
                    if (this.id == 'zebra') {
                        $('#hidden_inputs').append('<input type="hidden" id="daemon" name="daemon" value="zebra" />');
                        $('#hidden_inputs').append('<input type="hidden" id="password" name="password" value="' + passwords.zebra + '" />');
                    } else if (this.id == 'ripd') {
                        $('#hidden_inputs').append('<input type="hidden" id="daemon" name="daemon" value="ripd" />');
                        $('#hidden_inputs').append('<input type="hidden" id="password" name="password" value="' + passwords.ripd + '" />');
                    } else if (this.id == 'ripngd') {
                        $('#hidden_inputs').append('<input type="hidden" id="daemon" name="daemon" value="ripngd" />');
                        $('#hidden_inputs').append('<input type="hidden" id="password" name="password" value="' + passwords.ripngd + '" />');
                    } else if (this.id == 'ospfd') {
                        $('#hidden_inputs').append('<input type="hidden" id="daemon" name="daemon" value="ospfd" />');
                        $('#hidden_inputs').append('<input type="hidden" id="password" name="password" value="' + passwords.ospfd + '" />');
                    } else if (this.id == 'ospf6d') {
                        $('#hidden_inputs').append('<input type="hidden" id="daemon" name="daemon" value="ospf6d" />');
                        $('#hidden_inputs').append('<input type="hidden" id="password" name="password" value="' + passwords.ospf6d + '" />');
                    } else if (this.id == 'bgpd') {
                        $('#hidden_inputs').append('<input type="hidden" id="daemon" name="daemon" value="bgpd" />');
                        $('#hidden_inputs').append('<input type="hidden" id="password" name="password" value="' + passwords.bgpd + '" />');
                    };
                    setTimeout(function() {
                        $('#quagga_shell_form input[name=command]').focus();
                    }, 1250);
                } else {
                    $('#vtysh_select').fadeOut('slow', function() { $('#custom_vtysh').fadeIn('slow') });
                    setTimeout(function() {
                        $('#quagga_shell_custom_form input[name=host]').focus();
                    }, 1250);
                }
            });
        }
    });
    $('#quagga_shell_form').ajaxForm({
        success: function(responseText) {
            $('#console_div').append(responseText);
            $('#console_div').scrollTo('max');
            history_index = null;
        }
    });
    $('#quagga_shell_custom_form').ajaxForm({
        success: function(responseText) {
            $('#console_div').append(responseText);
            $('#console_div').scrollTo('max');
            history_index = null;
        }
    })
});
</script>