var d = null; // global variable for our Deferred
$(document).ready(function(){
    $('#reboot_form').ajaxForm({
        target: '#result',
        success: function() {
            showResult();
        }
    });
    $("#please_wait").dialog({
        autoOpen: false,
        autoResize: true,
        show: 'slide',
        hide: 'slide',
        title: 'Rebooting...',
        buttons: {
            "OK": function() { $(this).dialog("close") }
        }
    });
    $("#rebooted").dialog({
        autoOpen: false,
        autoResize: true,
        show: 'slide',
        hide: 'slide',
        title: 'Reboot Successful',
        buttons: {
            "OK": function() { $(this).dialog("close"); location.href = '/System/Reboot' }
        }
    });
    $('#reboot').click(function(){
        $('#apply-changes').hide();
        $("#please_wait").dialog('open');
        stringDate = toISOTimestamp(new Date());
        $("#msg").append("<li>" + stringDate + ": Executed reboot.</li>");
        setTimeout(function () {
            check();
        }, 5000);
    });
    // What Mochikit does, it does extremely well...
    var check = function() {
        var url = "/version";
        stringDate = toISOTimestamp(new Date());
        d = loadJSONDoc(url);
        setTimeout(function () {
            d.cancel();
        }, 5000);
        var hostIsUp = function (meta) { // We get that URL but we really don't care what the result is since we're just checking that it is up
            $('#result').html('<div class="ui-state-highlight ui-corner-all" style="margin-top: 0px; padding: 0 .7em"><p><span class="ui-icon ui-icon-notice" style="float: left; margin-right: .3em;"></span>PyCI is back up.</p></div>');
            showResult();
            appendChildNodes('msg', LI(stringDate + ": Host is back online."));
            appendChildNodes('rebooted', P("Host has been rebooted successfully.  Click OK to be taken to the login screen."));
            $("#rebooted").dialog('open');
        };
        var fetchFailed = function (err) {
            // I'm using appendChildNodes here instead of $('#msg').append() since jQuery's .append() doesn't work inside the context of MochiKit functions.
            // Just one of those little quirks.
            appendChildNodes('msg', LI(stringDate + ": Host is still not responding..."));
             $('#result').html('<div class="ui-state-highlight ui-corner-all" style="margin-top: 0px; padding: 0 .7em"><p><span class="ui-icon ui-icon-notice" style="float: left; margin-right: .3em;"></span>Checking if we are back up...</p></div>');
            showResult();
            setTimeout(function () {
                check(); // "To iterate is human, to recurse divine." -L. Peter Deutsch
            }, 5000);
        };
        d.addCallbacks(hostIsUp, fetchFailed);
    };
});


