$(document).ready(function(){
    $("#tabs").tabs({ fx: { height: 'toggle', duration: 'fast' } });
    $("#change_password").dialog({
        autoOpen: false,
        autoResize: true,
        show: 'slide',
        hide: 'slide',
        title: _('Change User Password'),
        buttons: {
            "Submit": function() { $('#change_password_form').submit() },
            "Cancel": function() { $(this).dialog("close") }
        }
    });
    $("#raw_passwd").hide();
    $("#raw_shadow").hide();
    $("#raw_group").hide();
    $('#add_user').dialog({
        autoOpen: false,
        height: 500,
        width: 380,
        show: 'blind',
        title: _('Add User'),
        buttons: {
            "Submit": function() { $('#add_user_form').submit() },
            "Cancel": function() { $(this).dialog("close") }
        }
    });
    $('#add_group').dialog({
        autoOpen: false,
        height: 400,
        width: 380,
        show: 'blind',
        title: _('Add Group'),
        buttons: {
            "Submit": function() { $('#add_group_form').submit() },
            "Cancel": function() { $(this).dialog("close") }
        }
    });
    $("select[multiple]").asmSelect({
        addItemTarget: 'bottom',
        animate: true
    });
    var eventsMenu = {
        menuStyle: {
            width: '200px'
        },
        bindings: {
            'delete_user': function(t) {
                $('#users').delGridRow(t.id); // This just calls jqGrid's built-in delete function on the row
            },
            'delete_group': function(t) {
                $('#groups').delGridRow(t.id); // This just calls jqGrid's built-in delete function on the row
            },
            'pwchange': function(t) {
               $('#change_password').dialog("open");
               $('#change_password_user').val(t.id);
            },
            'pwdisable': function(t) {
                $.ajax({
                    type: "POST",
                    dataType: "json",
                    url: "/System/change_user_attribute",
                    data: {username: t.id, disable: true},
                    success: function(data){
                        $('#users').trigger("reloadGrid");
                    }
                });
            },
            'pwlock': function(t) { // TODO:  Figure out how to only show this if the account has a password set and is unlocked
                $.ajax({
                    type: "POST",
                    dataType: "json",
                    url: "/System/change_user_attribute",
                    data: {username: t.id, locked: true},
                    success: function(data){
                        $('#users').trigger("reloadGrid");
                    }
                });
            },
            'pwunlock': function(t) { // TODO:  Figure out how to only show this if the account is locked
                $.ajax({
                    type: "POST",
                    dataType: "json",
                    url: "/System/change_user_attribute",
                    data: {username: t.id, locked: false},
                    success: function(data){
                        $('#users').trigger("reloadGrid");
                    }
                });
            }
        }
    };
    var lastsel;
    jQuery('#users').jqGrid({
        url:'/System/users_json',
        datatype: "json",
        colNames:[_('User'), _('Password'), _('UID'), _('GID'), _('Comment'), _('Home Directory'), _('Shell')],
        colModel:[
            {name:'user',index:'user', editable:true},
            {name:'password',index:'password', width:110},
            {name:'uid',index:'uid', width:80, editable:true},
            {name:'gid',index:'gid', width:80, editable:true},
            {name:'gecos',index:'gecos', editable:true},
            {name:'homedir',index:'homedir', editable:true},
            {name:'shell',index:'shell', editable:true, edittype:"select", editoptions:{value:shells}}
        ],
        rowNum:10,
        rowList:[10,20,30],
        multiselect: false,
        toolbar: [true, "top"],
        width: 700,
        height: "100%",
        pager: jQuery('#pusers'),
        sortname: 'uid',
        viewrecords: true,
        sortorder: "asc",
        afterInsertRow: function(rowid, rowdata, rowelem) {
            $('#users #' + rowid).contextMenu('usersContextMenu', eventsMenu);
        },
        onSelectRow: function(id){
            if(id && id!==lastsel){
                jQuery('#users').restoreRow(lastsel);
                jQuery('#users').editRow(id,true); lastsel=id;
            }
        },
        editurl: "/System/update_users",
        caption: _("User Administration")
    }).navGrid("#pusers",{edit:false,add:false,del:true},{},{width:350},{}).navButtonAdd('#pusers',{
        caption:_("Add User"), onClickButton: function() {$('#add_user').dialog('open')}, position:"last", buttonimg : 'ui-icon ui-icon-plus'
        });
    ToolbarButtonAdd("#t_users", {
        title: _("Edit the /etc/passwd file directly"),
        caption: _("Edit /etc/passwd"),
        onClickButton: function() {
            $('#gbox_users').fadeOut('slow', function() {
            $('#raw_passwd').fadeIn('slow');
            });
        }
    });
    ToolbarButtonAdd("#t_users", {
        title: _("Edit the /etc/shadow file directly"),
        caption: _("Edit /etc/shadow"),
        onClickButton: function() {
            $('#gbox_users').fadeOut('slow', function() {
            $('#raw_shadow').fadeIn('slow');
            });
        }
    });
    ToolbarButtonAdd("#t_users", {
        title: _("Export this table to a spreadsheet"),
        caption: _("Export to spreadsheet"),
        onClickButton: function() { document.location.href = '/System/get_users_spreadsheet' }
        });
    $('#raw_passwd_cancel').click(function(){
            $('#raw_passwd').fadeOut('slow', function() {
            $('#gbox_users').fadeIn('slow');
            });
            return false;
        }
    );
    $('#raw_shadow_cancel').click(function(){
            $('#raw_shadow').fadeOut('slow', function() {
            $('#gbox_users').fadeIn('slow');
            });
            return false;
        }
    );
    $('#raw_passwd_form').ajaxForm({
        target: '#result',
        success: function() {
            $('#users').trigger("reloadGrid");
            showResult();
            $('#raw_passwd').fadeOut('slow', function() {
            $('#gbox_users').fadeIn('slow');
            });
        }
    });
    $('#raw_shadow_form').ajaxForm({
        target: '#result',
        success: function() {
            $('#users').trigger("reloadGrid");
            showResult();
            $('#raw_shadow').fadeOut('slow', function() {
            $('#gbox_users').fadeIn('slow');
            });
        }
    });
    $('#change_password_form').ajaxForm({
        target: '#result',
        success: function() {
            $('#change_password').dialog("close");
            $('#users').trigger("reloadGrid");
            showResult();
        }
    });
    $('#add_user_form').ajaxForm({
        target: '#result',
        success: function() {
            $('#add_user').dialog("close");
            $('#users').trigger("reloadGrid");
            showResult();
        }
    });
    $('#add_group_form').ajaxForm({
        target: '#result',
        success: function() {
            $('#add_group').dialog("close");
            $('#groups').trigger("reloadGrid");
            showResult();
        }
    });
    jQuery('#groups').jqGrid({
        url:'/System/groups_json',
        datatype: "json",
        colNames:[_('Group'),_('GID'),_('Users')],
        colModel:[
            {name:'group',index:'group', width:30, editable:true},
            {name:'gid',index:'gid', width:30, editable:true},
            {name:'users',index:'users', editable:true}
        ],
        rowNum:10,
        rowList:[10,20,30],
        multiselect: false,
        toolbar: [true, "top"],
        width: 700,
        height: "100%",
        pager: jQuery('#pgroups'),
        sortname: 'gid',
        viewrecords: true,
        sortorder: "asc",
        afterInsertRow: function(rowid, rowdata, rowelem) {
            $('#groups #' + rowid).contextMenu('groupsContextMenu', eventsMenu);
        },
        onSelectRow: function(id){
            if(id && id!==lastsel){
                jQuery('#groups').restoreRow(lastsel);
                jQuery('#groups').editRow(id,true); lastsel=id;
            }
        },
        editurl: "/System/update_groups",
        caption: _("User Administration")
    }).navGrid("#pgroups",{edit:false,add:false,del:true},{},{width:350},{}).navButtonAdd('#pgroups',{
        caption:_("Add Group"), onClickButton: function() {$('#add_group').dialog('open')}, position:"last"
        });
    ToolbarButtonAdd("#t_groups", {
        title: _("Edit the /etc/group file directly"),
        caption: _("Edit /etc/group"),
        onClickButton: function() {
            $('#gbox_groups').fadeOut('slow', function() {
            $('#raw_group').fadeIn('slow');
            });
        }
    });
    ToolbarButtonAdd("#t_groups", {
        title: _("Export this table to a spreadsheet"),
        caption: _("Export to spreadsheet"),
        onClickButton: function() { document.location.href = '/System/get_groups_spreadsheet' }
        });
    $('#raw_group_cancel').click(function(){
            $('#raw_group').fadeOut('slow', function() {
            $('#gbox_groups').fadeIn('slow');
            });
            return false;
        }
    );
    $('#raw_group_form').ajaxForm({
        target: '#result',
        success: function() {
            $('#groups').trigger("reloadGrid");
            showResult();
            $('#raw_group').fadeOut('slow', function() {
            $('#gbox_groups').fadeIn('slow');
            });
        }
    });
    $("#change_password_form").validate({
        rules: {
            password: {
                required: true,
                minlength: 5
            },
            confirm_password: {
                required: true,
                minlength: 5,
                equalTo: "#password"
            }
        }
    });
    $("#add_user_form").validate({
        rules: {
            add_user_username: {
                required: true
            }
        }
    });
    $("#add_group_form").validate({
        rules: {
            add_group_groupname: {
                required: true
            }
        }
    });
});