speedDataPoints = null;
updateInterval = 2000;
speed_update = false;
function updateSpeed() {
    loadOptions = {
        legend: {position: 'sw'},
        xaxis: {
            mode: "time",
            timeformat: "%H:%M:%S"
        }
    };
    if (!speedDataPoints) {
        $.getJSON("/Utilities/average_speed", null, function(json){
            speedDataPoints = json;
        });
    };
    if (speed_update) {
        setTimeout(function() {
            $.getJSON("/Utilities/average_speed", null, function(json){
                speedDataPoints[0].data.push(json[0].data[0]);
                // The following keeps the number of data points in the graph at 15
                if (speedDataPoints[0].data.length > 15) {
                    speedDataPoints[0].data.shift();
                }
                $.plot($("#speed"), speedDataPoints, loadOptions);
                server_status = json[0].server_status;
                if (contains(_("stopped"), server_status)) {
                    speed_update = false;
                    $('#speed_dialog').dialog('option', 'title', 'Client Disconnected');
                    speedDataPoints = null;
                } else {
                    updateSpeed();
                };
            });
        }, updateInterval);
    }
};
function updateStatus() {
    $('#speed_test_server_status').load('/Utilities/speedtest_service_control?oper=status', '', function() {
        speedTestStatus = $('#speed_test_server_status').html();
        if (contains(_("Started"), speedTestStatus)) {
            $('#speed_dialog').dialog('open');
            speed_update = true;
            updateSpeed();
            return true;
        };
    })
}
$(document).ready(function(){
    $('#start_speed_daemon_form').ajaxForm({
        target: '#result',
        success: function(responseText) {
            showResult();
            speed_update = true;
            $('#speed_dialog').dialog('open');
            $('#speed_dialog').dialog('option', 'title', 'Average Speed');
            setTimeout(function() {
                updateStatus();
            }, 1000);
        }
    });
    $('#stop_speed_daemon_form').ajaxForm({
        target: '#result',
        success: function(responseText) {
            showResult();
            $('#speed_dialog').dialog('close');
            setTimeout(function() {
                updateStatus();
            }, 1000);
        }
    });
    $('#speed_dialog').dialog({
        autoOpen: false,
        show: 'slide',
        hide: 'slide',
        title: 'Average Speed',
        width: 500,
        height: 300,
        resizable: true,
        beforeclose: function(event, ui) {
            speed_update = false;
            setTimeout(function() {
                updateStatus();
            }, 1000);
        }
    });
    updateStatus();
});