// This function will add a new button to a jqGrid toolbar (mostly the same as jqGrid's NavAddButton function)
// The 'tbar' variable is the toolbar ID you want to append a button to.  jqGrid names toolbar ids using the following convention:
//      #t_<grid_id>
//
// So if my grid was '#users' the tbar value to pass would be '#t_users'
function ToolbarButtonAdd(tbar, p) {
    p = $.extend({
        caption : "newButton",
        title: '',
        buttonimg : 'ui-icon ui-icon-newwin',
        onClickButton: null,
        position : "last"
    }, p ||{});
    if (tbar) {
        $(tbar).append('<table id="toolbar_table"><tr id="toolbar_tr"></tr></table>');
        var tbartable = $('#toolbar_table',tbar)[0];
        var tbd = $("<td class='ui-pg-button ui-corner-all'></td>");
        $(tbd).append("<div style='cursor:pointer'><span class='"+p.buttonimg+"'></span>"+p.caption+"</div>");
        if(p.id) {$(tbd).attr("id",p.id);}
        if(p.position=='first'){
            if(tbartable.rows[0].cells.length ===0 ) {
                $("tr",tbartable).append(tbd);
            } else {
                $("tr td:eq(0)",tbartable).before(tbd);
            }
        } else {
            $("tr",tbartable).append(tbd);
        }
        $(tbd,tbartable)
        .attr("title",p.title  || "")
        .click(function(e){
            if ($.isFunction(p.onClickButton) ) { p.onClickButton(); }
            e.stopPropagation();
            return false;
        })
        .hover(
            function () {$(this).addClass("ui-state-hover");},
            function () {$(this).removeClass("ui-state-hover");}
        );
    };
};