## -*- coding: utf-8 -*-
<%
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['service']['list_items']
%>
<div id="accordion">
% for section in plugin_dict['ddns_conf'].sections:
    % if 'service' in section['config']:
    <%
    ## Replace the domain dots with underscores since javascript doesn't like dots in IDs
    underscored_domain = section['options']['domain'].replace('.', '_')
    %>
    <h3 id="header_${underscored_domain}"><a href="#">${section['options']['domain']}</a></h3>
    <div id="accordion_section_div">
    <div id="${underscored_domain}_form_div">
    <form id="ddns_form_${underscored_domain}" class="ddns_form_class" method="post" action="/Network/update_ddns">
        <input type="hidden" name="config" value="${section['config'][1]}" />
        <table id="${underscored_domain}_table" align="center" width="100%">
            <tr>
                <td style="width: 10em;"><label for="${underscored_domain}_delete">${_("Delete")}</label></td>
                <td align="center"><input type="checkbox" id="${underscored_domain}_delete" name="delete" value="${section['options']['domain']}" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="${underscored_domain}_options_tr">
            <td style="width: 10em;">
                <select id="${underscored_domain}_options" name="options" title="${_('Select a Dynamic DNS option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['service'].keys():
            <%
            try:
                # NOTE: Using the option title is just a shortcut until I add
                #       full help texts that are i18n-aware (like interfaces).
                option_help = plugin_dict['validation_dict']['service'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${underscored_domain}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${underscored_domain}_options_tr").change(function(){
            onSelectChange($("#${underscored_domain}_options option:selected"), $('#${underscored_domain}_table'), '/Network/ddns_options_meta', 'service');
        });
        $('#ddns_form_${underscored_domain}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['service'].keys()):
## The if/else bits here are necessary because Internet Explorer will crap out of there is a trailing comma (IE is a blight on the Internet!)
            % if index < len(plugin_dict['validation_dict']['service'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=ddns&section=service"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=ddns&section=service"
                }
            % endif
        % endfor
            }
        });
        % for key, value in section['options'].items():
            addField('/Network/ddns_options_meta', $('#${underscored_domain}_table'), '${key}', '${value}', 'service');
        % endfor
    });
    </script>
    % endif
% endfor
## New Route section
    <h3 id="header_new_ddns"><a href="#">${_("New Dynamic DNS Config")}</a></h3>
    <div id="accordion_section_div">
## Easy Buttons
    <div id="easy_buttons_div" class="ui-widget accordion_float_right">
    <h4 class="ui-state-active ui-corner-top ui-widget-header">&nbsp;<strong>${_("Easy Buttons")}</strong></h4>
    <table id="easy_buttons_table" width="100%" align="center">
        <tr>
            <td><button id="dyndns" class="fg-button ui-state-default ui-corner-all">${_("Defaults for dyndns.org")}</button></td>
        </tr>
        <tr>
            <td><button id="zoneedit" class="fg-button ui-state-default ui-corner-all">${_("Defaults for zoneedit.com")}</button></td>
        </tr>
        <tr>
            <td><button id="changeip" class="fg-button ui-state-default ui-corner-all">${_("Defaults for changeip.com")}</button></td>
        </tr>
        <tr>
            <td><button id="noip" class="fg-button ui-state-default ui-corner-all">${_("Defaults for no-ip.com")}</button></td>
        </tr>
        <tr>
            <td><button id="afraid_org" class="fg-button ui-state-default ui-corner-all">${_("Defaults for freedns.afraid.org")}</button></td>
        </tr>
    </table>
    </div>
    <div id="new_ddns_form_div">
    <form id="new_ddns_form" class="ddns_form_class" method="post" action="/Network/add_ddns">
        <table id="new_ddns_table" align="center">
            <tr>
                <td style="width: 10em;">${_("DDNS Config Name")}</td>
                <td><input type="text" id="config" name="config" size="18"></td>
            </tr>
        </table>
        <table align="center">
        <tr id="new_ddns_options_tr">
            <td style="width: 10em;">
                <select id="new_ddns_options" name="options" title="${_('Select an ddns option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['service'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['service'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
</div>
<script type="text/javascript">
$(document).ready(function(){
    var count = 0;
    mandatoryField('/Network/ddns_options_meta', $('#new_ddns_table'), 'service_name', '', 'service');
    $('#new_ddns_options').removeOption('service_name');
    mandatoryField('/Network/ddns_options_meta', $('#new_ddns_table'), 'domain', '', 'service');
    $('#new_ddns_options').removeOption('domain');
    mandatoryField('/Network/ddns_options_meta', $('#new_ddns_table'), 'enabled', '1', 'service');
    $('#new_ddns_options').removeOption('enabled');
    mandatoryField('/Network/ddns_options_meta', $('#new_ddns_table'), 'username', '', 'service');
    $('#new_ddns_options').removeOption('username');
    mandatoryField('/Network/ddns_options_meta', $('#new_ddns_table'), 'password', '', 'service');
    $('#new_ddns_options').removeOption('password');
    mandatoryField('/Network/ddns_options_meta', $('#new_ddns_table'), 'ip_source', '', 'service');
    $('#new_ddns_options').removeOption('ip_source');
    mandatoryField('/Network/ddns_options_meta', $('#new_ddns_table'), 'check_interval', '1', 'service');
    $('#new_ddns_options').removeOption('check_interval');
    mandatoryField('/Network/ddns_options_meta', $('#new_ddns_table'), 'check_unit', 'hours', 'service');
    $('#new_ddns_options').removeOption('check_unit');
    mandatoryField('/Network/ddns_options_meta', $('#new_ddns_table'), 'force_interval', '72', 'service');
    $('#new_ddns_options').removeOption('force_interval');
    mandatoryField('/Network/ddns_options_meta', $('#new_ddns_table'), 'force_unit', 'hours', 'service');
    $('#new_ddns_options').removeOption('force_unit');
    $("#new_ddns_options").selectmenu({
        width: 120,
        menuWidth: 500,
        maxHeight: 300,
        format: optionHelpFormatting
    });
    $("#new_ddns_options_tr").change(function(){
        onSelectChange($("#new_ddns_options option:selected"), $('#new_ddns_table'), '/Network/ddns_options_meta', 'service');
    });
    $('#new_ddns_form').validate({
        errorPlacement: function(error, element) {
            error.appendTo(element.parent("td").next("td"));
        },
        focusCleanup: true,
        rules: {
    % for index, option in enumerate(plugin_dict['validation_dict']['service'].keys()):
## The if/else bits here are necessary because Internet Explorer will crap out of there is a trailing comma (IE is a blight on the Internet!)
        % if index < len(plugin_dict['validation_dict']['service'].keys()) - 1:
            ${option}: {
                required: true,
                remote: "/Network/validate_option?config=ddns&section=service"
            },
        % else:
            ${option}: {
                required: true,
                remote: "/Network/validate_option?config=ddns&section=service"
            }
        % endif
    % endfor
        }
    });
    $("#accordion").hide();
    $("#accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#accordion").fadeIn('slow');
        $("#accordion").accordion('activate', 0);
    }, 500);
    $('.ddns_form_class*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {reloadTab($("#accordion"));}, 500);
                    rebootRequired();
                };
            }
        })
    });
    var addFieldPartial = partial(addField, '/Network/ddns_options_meta', $('#new_ddns_table'));
    var section = 'service';
    function easyDDNS(provider) {
        // This function just saves repetitive code
        var d = new Deferred();
        d.addCallback(addFieldPartial('ip_network', 'wan', section));
        d.addCallback($('#new_ddns_table input[name="service_name"]').val(provider));
        d.addCallback($('#new_ddns_table select[name="ip_source"]').selectOptions('network'));
        d.addCallback(reloadSelectmenu($('#new_ddns_table select[name="ip_source"]')));
        jTipReload();
    };
    $('#dyndns').click(function() {
        easyDDNS('dyndns.org');
    });
    $('#zoneedit').click(function() {
        easyDDNS('zoneedit.com');
    });
    $('#changeip').click(function() {
        easyDDNS('changeip.com');
    });
    $('#afraid_org').click(function() {
        easyDDNS('freedns.afraid.org');
    });
    $('#noip').click(function() {
        easyDDNS('no-ip.com');
    });
    jTipReload();
});
</script>
