## -*- coding: utf-8 -*-
<%
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['defaults']['list_items']
%>
<div id="defaults_accordion">
% for section in plugin_dict['firewall_conf'].sections:
    % if 'defaults' in section['config']:
    <%
    defaults = "_".join(section['options'].values())
    defaults = defaults.replace('.', '_')
    defaults = defaults.replace(':', '_')
    %>
    <h3><a href="#defaults_${defaults}">Defaults</a></h3>
    <div id="accordion_section_div">
    <div id="${defaults}_form_div">
    <form id="defaults_form_${defaults}" class="defaults_form_class" method="post" action="/Network/update_firewall_defaults">
        <table id="${defaults}_table" align="center" width="100%">
            <tr>
                <td style="width: 10em;"><label for="${defaults}_delete">${_("Delete")}</label></td>
                <td align="center"><input type="checkbox" id="${defaults}_delete" name="delete" value="${defaults}" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="${defaults}_options_tr">
            <td style="width: 10em;">
                <select id="${defaults}_options" name="options" title="${_('Select a defaults option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['defaults'].keys():
            <%
            try:
                # NOTE: Using the option title is just a shortcut until I add
                #       full help texts that are i18n-aware (like interfaces).
                option_help = plugin_dict['validation_dict']['defaults'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${defaults}_options_tr").change(function(){
            onSelectChange($("#${defaults}_options option:selected"), $('#${defaults}_table'), '/Network/firewall_options_meta', 'defaults');
        });
        % for key, value in section['options'].items():
            addField('/Network/firewall_options_meta', $('#${defaults}_table'), '${key}', '${value}', 'defaults');
            $('#${defaults}_options').removeOption('${key}')
        % endfor
        $("#${defaults}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $('#defaults_form_${defaults}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['defaults'].keys()):
## The if/else bits here are necessary because Internet Explorer will crap out of there is a trailing comma (IE is a blight on the Internet!)
            % if index < len(plugin_dict['validation_dict']['defaults'].keys()):
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=firewall&section=defaults"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=firewall&section=defaults"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
    % endif
% endfor
<script type="text/javascript">
$(document).ready(function(){
    var count = 0;
    $("#defaults_accordion").hide();
    $("#defaults_accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#defaults_accordion").fadeIn('slow');
        $("#defaults_accordion").accordion('activate', 0);
    }, 500);
    $('.defaults_form_class*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {reloadTab($("#defaults_accordion"));}, 500);
                    rebootRequired();
                };
            }
        })
    });
    jTipReload();
});
</script>