## -*- coding: utf-8 -*-
<%
alias_configs = [a for a in plugin_dict['network_conf'].sections if 'alias' in a['config']]
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['alias']['list_items']
del plugin_dict['validation_dict']['interface']['list_items']
count = 0 # Used to delay filling out the non-active accordions
%>
<style type="text/css">
    .status_div { display: block; float: right; width: 25em; background: #FFF; }
    .status_header { margin: 0; padding: 0; border: 0; outline: 0; }
</style>
<div id="accordion">
% for section in plugin_dict['network_conf'].sections:
    % if 'interface' in section['config']:
    <%
    count += 1
    underscored_config = "_".join(section['config'])
    bridged = None
    ifname = None

    # Is this a bridge interface?
    if 'type' in section['options'] and section['options']['type'] == 'bridge':
        bridged = section['options']['ifname']
        ifname = 'br-' + section['config'][1]
    else: # Use the regular ifname
        if 'ifname' in section['options']:
            ifname = section['options']['ifname']

    if ifname:
        iface_status = plugin_dict['interface_stats'][ifname]
        ip_addresses = iface_status['inets']
        ipv6_addresses = iface_status['inet6s']
    %>
    <h3 id="header_${section['config'][1]}"><a href="#">${section['config'][1]}</a></h3>
    <div id="accordion_section_div">
    <div id="${section['config'][1]}_status_div" class="status_div ui-widget">
## Interface status section
    <h4 class="ui-state-active ui-corner-top status_header ui-widget-header">&nbsp;${_("Interface Status")}</h4>
    <table id="${section['config'][1]}_status_table" width="100%" align="center">
   %if ifname:
    %if bridged:
        <tr>
## TODO:  Make this work with jTip popups for each individual interface
            <td><strong>${_("Bridged Interfaces:")}</strong></td><td><a href="/Network/interface_status_tip?width=475&interface=${bridged}" id="${section['config'][1]}_${bridged}" class="jTip" name="${bridged}">${bridged}</a></td>
        </tr>
    %endif
        <tr>
            <td><strong>${_("State:")}</strong></td>
            <td>
            %if iface_status['state'] == 'DOWN':
                <span style="color: red;">${iface_status['state']}</span>
            %else:
                ${iface_status['state']}
            %endif
            </td>
        </tr>
    %for inet in ip_addresses:
        <tr valign="top">
            <td><strong>${_("IP Address:")}</strong></td>
            <td>
                ${inet['inet']}<br />
                Broadcast: ${inet['broadcast']}<br />
                Scope: ${inet['scope']}
            </td>
        </tr>
    %endfor
    %for inet6 in ipv6_addresses:
        <tr valign="top">
            <td><strong>${_("IPv6 Address:")}</strong></td>
            <td>
                ${inet6['inet6']}<br />
                ${_("Scope:")} ${inet6['scope']}
            </td>
        </tr>
    %endfor
        <tr>
            <td><strong>MAC:</strong></td><td>${iface_status['mac']}</td>
        </tr>
        <tr>
            <td><strong>MTU:</strong></td><td>${iface_status['mtu']}</td>
        </tr>
        <tr>
            <td><strong>link:</strong></td><td>${iface_status['link']}</td>
        </tr>
        <tr>
            <td><strong>qdisc:</strong></td><td>${iface_status['qdisc']}</td>
        </tr>
    %if iface_status['qlen']:
        <tr>
            <td><strong>qlen:</strong></td><td>${iface_status['qlen']}</td>
        </tr>
    %endif
    %if iface_status['flags']:
        <tr valign="top">
            <td><strong>${_("Flags:")}</strong></td>
            <td>
            %for flag in iface_status['flags']:
                %if flag == 'NO-CARRIER':
                    <span style="color: red;">${flag}</span><br />
                %elif flag == 'UP':
                    <span style="color: green;">${flag}</span><br />
                %else:
                    ${flag}<br />
                %endif
            %endfor
            </td>
        </tr>
    %endif
   %else:
        <tr valign="top">
            <td>No status information available</td>
        </tr>
   %endif
    </table>
    </div>
## Interface section
    <div id="${section['config'][1]}_form_div">
    <form id="interfaces_form_${section['config'][1]}" class="interfaces_form_class" method="post" action="/Network/update_interfaces">
## TODO:  Figure out a good way to specify the order in which the key/value pairs display
        <input type="hidden" name="config" value="${underscored_config}" />
        <table id="${section['config'][1]}_interface_table" align="center">
            <tr>
                <td style="width: 10em;">${_("Interface name")}</td><td><input id="${section['config'][1]}" type="text" name="rename" size="18" value="${section['config'][1]}" /></td>
            </tr>
            <tr>
                <td style="width: 10em;"><label for="${section['config'][1]}_delete">${_("Delete this interface")}</label></td>
                <td align="center"><input type="checkbox" id="${section['config'][1]}_delete" name="delete" value="${section['config'][1]}" /></td>
            </tr>
        </table>
        <table id="${section['config'][1]}_options_table" align="center">
        <tr id="${section['config'][1]}_options_tr">
            <td style="width: 10em;">
                <select id="${section['config'][1]}_options" name="options" title="${_('Select an interface option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['interface'].keys():
            <%
            try:
                option_help = plugin_dict['option_help'][option]['help']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
## Alias section
<%
aliases = [a for a in alias_configs if a['options']['interface'] == section['config'][1]]
%>
    <h3>Aliases</h3>
  %if not aliases:
    <div id="${section['config'][1]}_alias_accordion" class="alias_accordion_class"></div>
    <p>No aliases are defined for this interface</p>
  %else:

    <div id="${section['config'][1]}_alias_accordion" class="alias_accordion_class">
  %for alias in aliases:
    <%
    underscored_config = "_".join(alias['config'])
    %>
    <h3 id="header_alias_${alias['config'][1]}"><a href="#">${alias['config'][1]}</a></h3>
    <div id="${alias['config'][1]}_form_div">
    <form id="alias_form_${alias['config'][1]}" class="alias_form_class" method="post" action="/Network/update_interfaces">
## TODO:  Figure out a good way to specify the order in which the key/value pairs display
        <input type="hidden" name="config" value="${underscored_config}" />
        <table id="${alias['config'][1]}_table" align="center">
            <tr>
                <td style="width: 10em;">${_("Alias name")}</td><td><input id="${alias['config'][1]}" type="text" name="alias_rename" size="18" value="${alias['config'][1]}" /></td>
            </tr>
            <tr>
                <td style="width: 10em;"><label for="${alias['config'][1]}_delete">${_("Delete this alias")}</label></td>
                <td align="center"><input type="checkbox" id="${alias['config'][1]}_delete" name="delete" value="${alias['config'][1]}" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="${alias['config'][1]}_options_tr">
            <td style="width: 10em;"><select id="${alias['config'][1]}_options" name="options" title="${_('Select an interface option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['alias'].keys():
            <%
            try:
                option_help = plugin_dict['option_help'][option]['help']
            except:
                option_help = _("No help text available")
            %>
            <option value="${option}">${option} - ${option_help}</option>
        % endfor
            </select>
            </td>
            <td style="width: 14.3em; text-align: right;">
                <button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button>
            </td>
        </tr>
        </table>
    </form>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${alias['config'][1]}_options_tr").change(function(){
            onSelectChange($("#${alias['config'][1]}_options option:selected"), $('#${alias['config'][1]}_table'), '/Network/interface_options_meta', 'alias');
        });
        $("#${alias['config'][1]}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $('#alias_form_${alias['config'][1]}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['alias'].keys()):
            % if index < len(plugin_dict['validation_dict']['alias'].keys()) - 1:
                ${option}: {
                    required: false,
                    remote: "/Network/validate_option?config=network&section=alias"
                },
            % else:
                ${option}: {
                    required: false,
                    remote: "/Network/validate_option?config=network&section=alias"
                }
            % endif
        % endfor
            }
        });
    // Add all the current options to the alias table for this interface:
    % if count < 3:
        % for key, value in alias['options'].items():
        addField('/Network/interface_options_meta', $('#${alias['config'][1]}_table'), '${key}', '${value}', 'alias');
        % endfor
    % else:
        % for key, value in alias['options'].items():
        setTimeout(function() {
            addField('/Network/interface_options_meta', $('#${alias['config'][1]}_table'), '${key}', '${value}', 'alias');
        }, 2000);
        % endfor
    % endif
    });
    </script>
  %endfor
    </div>
  %endif
    <p><button id="${section['config'][1]}_add_alias_button" class="fg-button ui-state-default ui-corner-all alias_button">Add Alias</button></p>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${section['config'][1]}_options_tr").change(function(){
            onSelectChange($("#${section['config'][1]}_options option:selected"), $('#${section['config'][1]}_interface_table'), '/Network/interface_options_meta', 'interface');
        });
        $("#${section['config'][1]}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $('#interfaces_form_${section['config'][1]}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['interface'].keys()):
            % if index < len(plugin_dict['validation_dict']['interface'].keys()) - 1:
                ${option}: {
                    required: false,
                    remote: "/Network/validate_option?config=network&section=interface"
                },
            % else:
                ${option}: {
                    required: false,
                    remote: "/Network/validate_option?config=network&section=interface"
                }
            % endif
        % endfor
            }
        });

## Added a 3-second delay here if this isn't the first accordion to speed up the initial page load time
    % if count < 3:
    // Add all the current options for this interface to the table
        % for key, value in section['options'].items():
        addField('/Network/interface_options_meta', $('#${section['config'][1]}_interface_table'), '${key}', '${value}', 'interface');
        % endfor
    % else:
        % for key, value in section['options'].items():
        setTimeout(function() {
            addField('/Network/interface_options_meta', $('#${section['config'][1]}_interface_table'), '${key}', '${value}', 'interface');
        }, 3000);
        % endfor
    % endif
    });
    </script>
    % endif
% endfor
</div>
<div id="new_alias">
    <form id="new_alias_form" class="alias_form_class option_select_list" method="post" action="/Network/add_interface">
    <table align="center" id="new_alias_table">
        <tr>
            <td style="width: 10em;">${_("Alias Name")}</td>
            <td><input type="text" id="alias_config" name="alias_config" size="18" /></td>
        </tr>
    </table>
    <table id="new_alias_table2" align="center">
        <tr id="select_alias_option">
            <td style="width: 10em;"><select id="alias_options" name="options" title="${_('Select an alias option')}">
                <option value="">${_("Add option...")}</option>
    % for option in plugin_dict['validation_dict']['alias'].keys():
        <%
            try:
                option_help = plugin_dict['option_help'][option]['help']
            except:
                option_help = _("No help text available")
        %>
                <option value="${option}">${option} - ${option_help}</option>
    % endfor
                </select>
            </td>
            <td style="width: 13.6em; text-align: right;">
                <button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button>
            </td>
        </tr>
    </table>
    </form>
</div>
<script type="text/javascript">
$(document).ready(function(){
    var count = 0;
    $('#new_alias').hide();
    $("#accordion").hide();
    $("#accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#accordion").fadeIn('slow');
        $("#accordion").accordion('activate', 1);
        // Initialize alias accordion (if any)
        $(".alias_accordion_class").each(function(n) {
            $(this).accordion({ collapsible: true, autoHeight: true });
        });
    }, 500);
    $('.interfaces_form_class*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {
                        reloadTab($("#accordion"));
                        rebootRequired();
                    }, 500);
                };
            }
        })
    });
    $('.alias_form_class*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {
                        reloadTab($("#accordion"));
                        rebootRequired();
                    }, 500);
                };
            }
        })
    });
    // These just change the accordion header to match the value of the interface name if the user changes it
    $("input[name='rename']").blur(function () {
        thisHeaderID = '#header_' + $(this).attr('id');
        $(thisHeaderID).html('<a href="#">' + $(this).attr('value') + '</a>');
    });
    $("input[name='alias_rename']").blur(function () {
        thisHeaderID = '#header_alias_' + $(this).attr('id');
        $(thisHeaderID).html('<a href="#">' + $(this).attr('value') + '</a>');
    });
    $("input[name='alias_config']").blur(function () {
        $('#header_new_alias' + count).html('<a href="#">' + $(this).attr('value') + '</a>');
    });
    // This enables the "add alias" button...
    $('.alias_button').each(function(n) {
        $(this).click(function() {
            count = count + 1;
            var interface = this.id.split('_')[0];
            var thisSection = '#' + interface + '_alias_accordion';
            var parentAccordion = $('#' + interface + '_alias_accordion');
//             var activeAccordion = parentAccordion.accordion('option', 'active');
            $('<h3 id="header_new_alias' + count + '"><a href="#">New Alias</a></h3>').appendTo(parentAccordion);
            $('#new_alias').appendTo(parentAccordion);
            parentAccordion.accordion('destroy');
            parentAccordion.accordion({ collapsible: true, autoHeight: false, active: false});
            $('#new_alias_form input[name="interface"]').attr({value: interface});
            setTimeout(function() {
                parentAccordion.accordion('activate', ':last');
            }, 500);
        });
    });
    $("#select_alias_option").change(function(){
        onSelectChange($("#alias_options option:selected"), $('#new_alias_table'), '/Network/interface_options_meta');
    });
    mandatoryField('/Network/interface_options_meta', $('#new_alias_table'), 'interface', '', 'interface');
    mandatoryField('/Network/interface_options_meta', $('#new_alias_table'), 'proto', '', 'interface');
    $("#alias_options").selectmenu({
        width: 120,
        menuWidth: 500,
        maxHeight: 300,
        format: optionHelpFormatting
    });
    jTipReload();
});
</script>
