## -*- coding: utf-8 -*-
<%inherit file="/plugin_base.mako"/>

## Create a basic form we're going to submit to our plugin:
<form id="notification_form" method="post" action="/Example/notification_test">
<table>
    <tr>
        <td><strong>Type an integer:</strong></td>
        <td>
            <input type="text" name="number" id="number" size="5" value="" />
        </td>
        ## Note: This extra empty TD is important for validation messages to appear properly
        <td>&nbsp;</td>
    <tr>
</table>
## Note the classes used with this button.  They make the button's appearance match jQuery-UI.
<p><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></p>
## Note that I wrapped the word, "Submit" inside ${_()}.  This is to ensure that that word gets included in gettext translations.
</form>
## For this example I'm putting all the JavaScript inside our template (just to show how it can be done)
<script type="text/javascript">
$(document).ready(function(){
    $('#notification_form').validate({ // This uses the jQuery Validation plugin included with PyCI
        errorPlacement: function(error, element) { // Tells the validation plugin where to display error messages
            error.appendTo(element.parent("td").next("td")); // In this example, we want the error message to appear in the TD after our input element
        },
        focusCleanup: true, // This removes the message when the input has focus (or adds it back if the focused element changes)
        rules: { // Here we define the validation rules for our form
            number: { // Each input element gets its own set of rules (see PyCI's network plugin for examples of how to use this with dynamically-generated forms).
                required: true, // This input element is required to be filled out
                remote: "/Example/validate_integer" // This URL is called to check the value of our input element
            } // Note: More advanced examples of the 'remote' parameter can be found in PyCI's Network plugin templates
        }
    });
    $('#notification_form').ajaxForm({ // This uses the jQuery Form plugin included with PyCI which turns any form into an AJAX form
        target: '#result', // PyCI's theme includes an empty/hidden div for displaying messages with id="result"
        // target: '#result' tells the Form plugin to replace the text of the 'result' div with the message returned by the form's action URL
        success: function(responseText) { // This method will be called if the form submission is successful
        // showResult() is the theme's message display function.
        // It will display whatever is contained in #result to the user (however the theme wants)
            showResult();
            // This conditional checks if the message contains "<strong>Success:</strong>" and if it does, displays the rebootRequired message.
            // Note: rebootRequired() is defined in the theme like showResult.
            if (contains(_("<strong>Success:</strong>"), responseText)) {
                // I find that a short delay before displaying the rebootRequired message makes for a smoother user experience:
                setTimeout(function() {
                    rebootRequired();
                }, 500);
            };
        }
    })
});
</script>