## -*- coding: utf-8 -*-
<%
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['ntpserver']['list_items']
del plugin_dict['validation_dict']['ntpclient']['list_items']
del plugin_dict['validation_dict']['ntpdrift']['list_items']

for section in plugin_dict['ntpclient_conf'].sections:
    if 'ntpclient' in section['config']:
        ntpclient_section = section
for section in plugin_dict['ntpclient_conf'].sections:
    if 'ntpdrift' in section['config']:
        ntpdrift_section = section
%>
<div id="accordion">
    <h3 id="header_ntpclient"><a href="#">${_("NTP Client Settings")}</a></h3>
    <div id="accordion_section_div">
    <div id="ntpclient_form_div">
    <form id="ntpclient_form_ntpclient" class="ntpclient_form_class" method="post" action="/Services/update_ntpclient_config">
        <input type="hidden" name="config" value="ntpclient" />
        <table id="ntpclient_table" align="center">
        % for key, value in ntpclient_section['options'].items():
            <tr>
                <td style="width: 10em;"><a href="/Services/ntpclient_options_meta?width=475&option=${key}&section=ntpclient" id="ntpclient_${key}" class="jTip" name="Option Help">${key}</a></td>
                <td><input type="text" id="${key}" name="${key}" size="18" value="${value}" /></td><td><span id="remove_option" class="ui-icon ui-icon-left ui-icon-closethick" style="cursor: pointer;" onclick="$(this).parent().parent().remove();return false;"></span></td>
            </tr>
        % endfor
        </table>
        <table align="center">
        <tr id="ntpclient_options_tr">
            <td style="width: 10em;">
                <select id="ntpclient_options" name="options" title="${_('Select an ntpclient option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['ntpclient'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['ntpclient'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#ntpclient_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#ntpclient_options_tr").change(function(){
            onSelectChange($("#ntpclient_options option:selected"), $('#ntpclient_table'), '/Services/ntpclient_options_meta', 'ntpclient');
        });
        $('#ntpclient_form_ntpclient').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
            % for index, option in enumerate(plugin_dict['validation_dict']['ntpclient'].keys()):
                % if index < len(plugin_dict['validation_dict']['ntpclient'].keys()) - 1:
                    ${option}: {
                        required: true,
                        remote: "/Services/validate_option?config=ntpclient&section=ntpclient"
                    },
                % else:
                    ${option}: {
                        required: true,
                        remote: "/Services/validate_option?config=ntpclient&section=ntpclient"
                    }
                % endif
            % endfor
            }
        });
    });
    </script>
## Drift section (only separate because that's how it is in the config file
    <h3 id="header_ntpdrift"><a href="#">${_("Drift Settings")}</a></h3>
    <div id="accordion_section_div">
    <div id="ntpdrift_form_div">
    <form id="ntpdrift_form_ntpdrift" class="ntpclient_form_class" method="post" action="/Services/update_ntpclient_config">
        <input type="hidden" name="config" value="ntpdrift" />
        <table id="ntpdrift_table" align="center">
        % for key, value in ntpdrift_section['options'].items():
            <tr>
                <td style="width: 10em;"><a href="/Services/ntpclient_options_meta?width=475&option=${key}&section=ntpdrift" id="ntpdrift_${key}" class="jTip" name="Option Help">${key}</a></td>
                <td><input type="text" id="${key}" name="${key}" size="18" value="${value}" /></td><td></td>
            </tr>
        % endfor
        </table>
        <table align="center">
        <tr id="ntpdrift_options_tr">
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#ntpdrift_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#ntpdrift_options_tr").change(function(){
            onSelectChange($("#ntpdrift_options option:selected"), $('#ntpdrift_table'), '/Services/ntpclient_options_meta', 'ntpdrift');
        });
        $('#ntpdrift_form_ntpdrift').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
            % for index, option in enumerate(plugin_dict['validation_dict']['ntpdrift'].keys()):
                % if index < len(plugin_dict['validation_dict']['ntpdrift'].keys()) - 1:
                    ${option}: {
                        required: true,
                        remote: "/Services/validate_option?config=ntpclient&section=ntpdrift"
                    },
                % else:
                    ${option}: {
                        required: true,
                        remote: "/Services/validate_option?config=ntpclient&section=ntpdrift"
                    }
                % endif
            % endfor
            }
        });
    });
    </script>
% for section in plugin_dict['ntpclient_conf'].sections:
    % if 'ntpserver' in section['config']:
    <%
    ## Replace the hostname dots with underscores since javascript doesn't like dots in IDs
    underscored_hostname = section['options']['hostname'].replace('.', '_')
    %>
    <h3 id="header_${underscored_hostname}"><a href="#">ntpserver ${section['options']['hostname']}</a></h3>
    <div id="accordion_section_div">
    <div id="${underscored_hostname}_form_div">
    <form id="ntpserver_form_${underscored_hostname}" class="ntpclient_form_class" method="post" action="/Services/update_ntpclient_config">
        <input type="hidden" name="config" value="${section['options']['hostname']}" />
        <table id="${underscored_hostname}_ntpserver_table" align="center">
            <tr>
                <td style="width: 10em;"><label for="${underscored_hostname}_delete">${_("Delete")}</label></td>
                <td align="center"><input type="checkbox" id="${underscored_hostname}_delete" name="delete" value="${section['options']['hostname']}" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="${underscored_hostname}_options_tr">
            <td style="width: 10em;">
                <select id="${underscored_hostname}_options" name="options" title="${_('Select an ntpclient option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['ntpserver'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['ntpserver'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $('#${underscored_hostname}_options').removeOption('hostname');
        $("#${underscored_hostname}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${underscored_hostname}_options_tr").change(function(){
            onSelectChange($("#${underscored_hostname}_options option:selected"), $('#${underscored_hostname}_ntpserver_table'), '/Services/ntpclient_options_meta', 'ntpserver');
        });
        $('#ntpserver_form_${underscored_hostname}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
            % for index, option in enumerate(plugin_dict['validation_dict']['ntpserver'].keys()):
                % if index < len(plugin_dict['validation_dict']['ntpserver'].keys()) - 1:
                    ${option}: {
                        required: true,
                        remote: "/Services/validate_option?config=ntpclient&section=ntpserver"
                    },
                % else:
                    ${option}: {
                        required: true,
                        remote: "/Services/validate_option?config=ntpclient&section=ntpserver"
                    }
                % endif
            % endfor
            }
        });
        % for key, value in section['options'].items():
        addField('/Services/ntpclient_options_meta', $('#${underscored_hostname}_ntpserver_table'), '${key}', '${value}', 'ntpserver');
        % endfor
    });
    </script>
    % endif
% endfor
## New NTP server section
    <h3 id="header_new_ntpserver"><a href="#">${_("New NTP Server")}</a></h3>
    <div id="accordion_section_div">
    <div id="new_ntpserver_form_div">
    <form id="new_ntpserver_form" class="ntpclient_form_class" method="post" action="/Services/add_ntpserver">
        <table id="new_ntpserver_table" align="center">
        </table>
        <table align="center">
        <tr id="new_ntpserver_options_tr">
            <td style="width: 10em;">
                <select id="new_ntpserver_options" name="options" title="${_('Select an ntpserver option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['ntpserver'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['ntpserver'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#new_ntpserver_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#new_ntpserver_options_tr").change(function(){
            onSelectChange($("#new_ntpserver_options option:selected"), $('#new_ntpserver_table'), '/Services/ntpclient_options_meta', 'ntpserver');
        });
        $('#new_ntpserver_form').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
            % for index, option in enumerate(plugin_dict['validation_dict']['ntpserver'].keys()):
                % if index < len(plugin_dict['validation_dict']['ntpserver'].keys()) - 1:
                    ${option}: {
                        required: true,
                        remote: "/Services/validate_option?config=ntpclient&section=ntpserver"
                    },
                % else:
                    ${option}: {
                        required: true,
                        remote: "/Services/validate_option?config=ntpclient&section=ntpserver"
                    }
                % endif
            % endfor
            }
        });
        mandatoryField('/Services/ntpclient_options_meta', $('#new_ntpserver_table'), 'hostname', '', 'ntpserver');
        $('#new_ntpserver_options').removeOption('hostname');
    });
    </script>
</div>
<script type="text/javascript">
$(document).ready(function(){
    var count = 0;
    $("#accordion").accordion({ collapsible: true, active: 0, autoHeight: false });
    $('.ntpclient_form_class*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {reloadTab($("#accordion"));}, 500);
                    rebootRequired();
                };
            }
        })
    });
    jTipReload();
});
</script>
