## -*- coding: utf-8 -*-
<%
from openwrt import fw_redirect
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['redirect']['list_items']
%>
<div id="redirect_accordion">
% for section in plugin_dict['firewall_conf'].sections:
    % if 'redirect' in section['config']:
    <%
    redirect = section['options'].values()
    redirect.sort()
    redirect = "_".join(redirect)
    redirect = redirect.replace('.', '_')
    redirect = redirect.replace(':', '_')
    # Get the iptables command line string for each rule:
    iptables_strings = fw_redirect(section['options'])
    iptables_string = ""
    if len(iptables_strings) > 1: # We have a set of rules
        iptables_string = '\n'.join(iptables_strings)
    else: # Just the one rule
        iptables_string = iptables_strings[0]
    # Now get the rules so we can make a human-readable form:
    rules = fw_redirect(section['options'], rules_output=True)
    for index, rule in enumerate(rules):
        if rule.target == 'ACCEPT':
            del rules[index]
    if len(rules) > 1:
        rule = rules[0]
        rule.protocol = 'tcpudp'
    else:
        rule = rules[0]
    %>
    <h3><a href="#redirect_${redirect}">Incoming Port: ${rule.destination_port}, Destination: ${rule.to_destination}, Protocol: ${rule.protocol}</a></h3>
    <div id="accordion_section_div">
    <div id="easy_buttons_div" class="ui-widget accordion_float_right">
    <h4 class="ui-state-active ui-corner-top ui-widget-header">&nbsp;<strong>${_("Easy Buttons")}</strong></h4>
    <table id="easy_buttons_table" width="100%" align="center">
        <tr>
            <td><button id="${redirect}_rules_button" class="fg-button ui-state-default ui-corner-all">${_("See the iptables command")}</button></td>
        </tr>
    </table>
    </div>
    <div id="${redirect}_form_div">
    <form id="redirect_form_${redirect}" class="redirect_form_class" method="post" action="/Network/update_port_forwarding">
        <input type="hidden" name="redirect" value="${redirect}" />
        <table id="${redirect}_table" align="center" width="100%">
            <tr>
                <td style="width: 10em;"><label for="${redirect}_delete">${_("Delete")}</label></td>
                <td align="center"><input type="checkbox" id="${redirect}_delete" name="delete" value="${redirect}" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="${redirect}_options_tr">
            <td style="width: 10em;">
                <select id="${redirect}_options" name="options" title="${_('Select a redirect option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['redirect'].keys():
            <%
            try:
                # NOTE: Using the option title is just a shortcut until I add
                #       full help texts that are i18n-aware (like interfaces).
                option_help = plugin_dict['validation_dict']['redirect'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    <div id="${redirect}_rules_dialog"><textarea id="${redirect}_iptables_rules" cols="80">${iptables_string}</textarea></div>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${redirect}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${redirect}_options_tr").change(function(){
            onSelectChange($("#${redirect}_options option:selected"), $('#${redirect}_table'), '/Network/firewall_options_meta', 'redirect');
        });
        $('#redirect_form_${redirect}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['redirect'].keys()):
            % if index < len(plugin_dict['validation_dict']['redirect'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=firewall&section=redirect"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=firewall&section=redirect"
                }
            % endif
        % endfor
            }
        });
        % for key, value in section['options'].items():
            addField('/Network/firewall_options_meta', $('#${redirect}_table'), '${key}', '${value}', 'redirect');
        % endfor
        });
        $('textarea#${redirect}_iptables_rules').autoResize({extraSpace : 40}).trigger('change');
        $('textarea#${redirect}_iptables_rules').center();
        $('#${redirect}_rules_dialog').dialog({
            autoOpen: false,
            height: 250,
            width: 800,
            show: 'slide',
            hide: 'slide',
            title: 'Command Line'
        });
        $("#${redirect}_rules_button").click(function() {
            $('#${redirect}_rules_dialog').dialog('open');
        });
    </script>
    % endif
% endfor
## New Port Forward section
    <h3 id="header_new_redirect"><a href="#">${_("New Port Forwarding Config")}</a></h3>
    <div id="accordion_section_div">
## Easy Buttons
    <div id="easy_buttons_div" class="ui-widget accordion_float_right">
    <h4 class="ui-state-active ui-corner-top ui-widget-header">&nbsp;<strong>${_("Easy Buttons")}</strong></h4>
    <table id="easy_buttons_table" width="100%" align="center">
        <tr>
            <td><button id="basic_tcp_forward" class="fg-button ui-state-default ui-corner-all">${_("Basic TCP Port Forward")}</button></td>
        </tr>
        <tr>
            <td><button id="basic_udp_forward" class="fg-button ui-state-default ui-corner-all">${_("Basic UDP Port Forward")}</button></td>
        </tr>
        <tr>
            <td><button id="basic_tcpudp_forward" class="fg-button ui-state-default ui-corner-all">${_("Basic TCP/UDP Port Forward")}</button></td>
        </tr>
    </table>
    </div>
    <div id="new_redirect_form_div">
    <form id="new_redirect_form" class="redirect_form_class" method="post" action="/Network/add_redirect">
        <table id="new_redirect_table" align="center">
        </table>
        <table align="center">
        <tr id="new_redirect_options_tr">
            <td style="width: 10em;">
                <select id="new_redirect_options" name="options" title="${_('Select an redirect option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['redirect'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['redirect'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        // Note:  partial() is part of MochiKit.Base
        var addFieldPartial = partial(addField, '/Network/firewall_options_meta', $('#new_redirect_table'));
        var section = 'redirect';
        $('#basic_tcp_forward').click(function() {
            addFieldPartial('proto', 'tcp', section);
            addFieldPartial('src', 'wan', section);
            addFieldPartial('src_dport', '', section);
            addFieldPartial('dest', 'lan', section);
            addFieldPartial('dest_port', '', section);
            addFieldPartial('dest_ip', '', section);
            jTipReload();
        });
        $('#basic_udp_forward').click(function() {
            addFieldPartial('proto', 'udp', section);
            addFieldPartial('src', 'wan', section);
            addFieldPartial('src_dport', '', section);
            addFieldPartial('dest', 'lan', section);
            addFieldPartial('dest_port', '', section);
            addFieldPartial('dest_ip', '', section);
            jTipReload();
        });
        $('#basic_tcpudp_forward').click(function() {
            addFieldPartial('proto', 'tcpudp', section);
            addFieldPartial('src', 'wan', section);
            addFieldPartial('src_dport', '', section);
            addFieldPartial('dest', 'lan', section);
            addFieldPartial('dest_port', '', section);
            addFieldPartial('dest_ip', '', section);
            jTipReload();
        });
        $("#new_redirect_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#new_redirect_options_tr").change(function(){
            onSelectChange($("#new_redirect_options option:selected"), $('#new_redirect_table'), '/Network/firewall_options_meta', section);
        });
        $('#new_redirect_form').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['redirect'].keys()):
            % if index < len(plugin_dict['validation_dict']['redirect'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=firewall&section=redirect"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=firewall&section=redirect"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
</div>
<script type="text/javascript">
$(document).ready(function(){
    $("#redirect_accordion").hide();
    $("#redirect_accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#redirect_accordion").fadeIn('slow');
        $("#redirect_accordion").accordion('activate', 0);
    }, 500);
    $('.redirect_form_class*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {reloadTab($("#redirect_accordion"));}, 500);
                    rebootRequired();
                };
            }
        })
    });
    jTipReload();
});
</script>
