## -*- coding: utf-8 -*-
<%
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['class']['list_items']
%>
<i>${_("It is recommended that these settings remain unchanged unless you really know what you're doing.")}</i>
<div id="class_accordion">
% for section in plugin_dict['qos_conf'].sections:
    % if 'class' in section['config']:
    <%
    underscored_class = section['config'][1].replace('.', '_')
    %>
    <h3 id="header_${underscored_class}"><a href="#">${section['config'][1]}</a></h3>
    <div id="class_accordion_section_div">
    <div id="${underscored_class}_form_div">
    <form id="class_form_${underscored_class}" class="class_form_class" method="post" action="/Network/update_qos">
        <input type="hidden" name="config" value="class ${section['config'][1]}" />
        <table id="${underscored_class}_table" align="center" width="100%">
            <tr>
                <td style="width: 10em;">${_("Class name")}</td><td><input id="${section['config'][1]}" type="text" name="rename" size="18" value="${section['config'][1]}" /></td>
            </tr>
            <tr>
                <td style="width: 10em;"><label for="${underscored_class}_delete">${_("Delete")}</label></td>
                <td align="center"><input type="checkbox" id="${underscored_class}_delete" name="delete" value="${section['config'][1]}" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="${underscored_class}_options_tr">
            <td style="width: 10em;">
                <select id="${underscored_class}_options" name="options" title="${_('Select a class option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['class'].keys():
            <%
            try:
                # NOTE: Using the option title is just a shortcut until I add
                #       full help texts that are i18n-aware (like class).
                option_help = plugin_dict['validation_dict']['class'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${underscored_class}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${underscored_class}_options_tr").change(function(){
            onSelectChange($("#${underscored_class}_options option:selected"), $('#${underscored_class}_table'), '/Network/qos_options_meta', 'class');
        });
        % for key, value in section['options'].items():
            addField('/Network/qos_options_meta', $('#${underscored_class}_table'), '${key}', '${value}', 'class');
        % endfor
        $('#class_form_${underscored_class}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['class'].keys()):
            % if index < len(plugin_dict['validation_dict']['class'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=class"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=class"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
    % endif
% endfor
## New QOS Class section
    <h3 id="header_new_class"><a href="#">${_("New QOS Class")}</a></h3>
    <div id="class_accordion_section_div">
    <div id="new_class_form_div">
    <p><strong>Note:</strong> Don't forget to add new classes to a classgroup.</p>
    <form id="new_class_form" class="class_form_class" method="post" action="/Network/add_qos_config">
        <input type="hidden" name="config" value="class" />
        <table id="new_class_table" align="center">
            <tr>
                <td style="width: 10em;">${_("Class name")}</td><td><input id="new_class_name" type="text" name="config" size="18" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="new_class_options_tr">
            <td style="width: 10em;">
                <select id="new_class_options" name="options" title="${_('Select an class option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['class'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['class'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#new_class_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#new_class_options_tr").change(function(){
            onSelectChange($("#new_class_options option:selected"), $('#new_class_table'), '/Network/qos_options_meta', 'class');
        });
        $('#new_class_form').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['class'].keys()):
            % if index < len(plugin_dict['validation_dict']['class'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=class"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=class"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
</div>
<script type="text/javascript">
$(document).ready(function(){
    $("#class_accordion").hide();
    $("#class_accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#class_accordion").fadeIn('slow');
        $("#class_accordion").accordion('activate', 0);
    }, 500);
    $('.class_form_class*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {reloadTab($("#class_accordion"));}, 500);
                    rebootRequired();
                };
            }
        })
    });
    jTipReload();
});
</script>