## -*- coding: utf-8 -*-
<%
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['classgroup']['list_items']
%>
<i>${_("It is recommended that these settings remain unchanged unless you really know what you're doing.")}</i>
<div id="classgroup_accordion">
% for section in plugin_dict['qos_conf'].sections:
    % if 'classgroup' in section['config']:
    <%
    underscored_classgroup = section['config'][1].replace('.', '_')
    %>
    <h3 id="header_${underscored_classgroup}"><a href="#">${section['config'][1]}</a></h3>
    <div id="classgroup_accordion_section_div">
    <div id="${underscored_classgroup}_form_div">
    <form id="classgroup_form_${underscored_classgroup}" class="classgroup_form_classgroup" method="post" action="/Network/update_qos">
        <input type="hidden" name="config" value="classgroup ${section['config'][1]}" />
        <table id="${underscored_classgroup}_table" align="center" width="100%">
            <tr>
                <td style="width: 10em;">${_("Classgroup name")}</td><td><input id="${section['config'][1]}" type="text" name="rename" size="18" value="${section['config'][1]}" /></td>
            </tr>
            <tr>
                <td style="width: 10em;"><label for="${underscored_classgroup}_delete">${_("Delete")}</label></td>
                <td align="center"><input type="checkbox" id="${underscored_classgroup}_delete" name="delete" value="${section['config'][1]}" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="${underscored_classgroup}_options_tr">
            <td style="width: 10em;">
                <select id="${underscored_classgroup}_options" name="options" title="${_('Select a classgroup option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['classgroup'].keys():
            <%
            try:
                # NOTE: Using the option title is just a shortcut until I add
                #       full help texts that are i18n-aware (like classgroup).
                option_help = plugin_dict['validation_dict']['classgroup'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${underscored_classgroup}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${underscored_classgroup}_options_tr").change(function(){
            onSelectChange($("#${underscored_classgroup}_options option:selected"), $('#${underscored_classgroup}_table'), '/Network/qos_options_meta', 'classgroup');
        });
        % for key, value in section['options'].items():
            addField('/Network/qos_options_meta', $('#${underscored_classgroup}_table'), '${key}', '${value}', 'classgroup');
        % endfor
    });
    </script>
    % endif
% endfor
## New QOS Classgroup section
    <h3 id="header_new_classgroup"><a href="#">${_("New QOS Classgroup")}</a></h3>
    <div id="classgroup_accordion_section_div">
    <div id="new_classgroup_form_div">
    <form id="new_classgroup_form" class="classgroup_form_classgroup" method="post" action="/Network/add_qos_config">
        <input type="hidden" name="config" value="classgroup" />
        <table id="new_classgroup_table" align="center">
            <tr>
                <td style="width: 10em;">${_("Classgroup name")}</td><td><input id="new_classgroup_name" type="text" name="config" size="18" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="new_classgroup_options_tr">
            <td style="width: 10em;">
                <select id="new_classgroup_options" name="options" title="${_('Select an classgroup option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['classgroup'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['classgroup'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#new_classgroup_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#new_classgroup_options_tr").change(function(){
            onSelectChange($("#new_classgroup_options option:selected"), $('#new_classgroup_table'), '/Network/qos_options_meta', 'classgroup');
        });
    });
    </script>
</div>
<script type="text/javascript">
$(document).ready(function(){
    $("#classgroup_accordion").hide();
    $("#classgroup_accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#classgroup_accordion").fadeIn('slow');
        $("#classgroup_accordion").accordion('activate', 0);
    }, 500);
    $('.classgroup_form_classgroup*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {reloadTab($("#classgroup_accordion"));}, 500);
                    rebootRequired();
                };
            }
        })
    });
    jTipReload();
});
</script>