## -*- coding: utf-8 -*-
<%
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['classify']['list_items']
count = 0 # This is because we'll have multiple tables with the same name
%>
<div id="classify_accordion">
% for section in plugin_dict['qos_conf'].sections:
    % if 'classify' in section['config']:
    <%
    count += 1
    underscored_classify = section['options']['target'].replace('.', '_') + str(count)
    description = ""
    for k, v in section['options'].items():
        if k == 'target':
            pass
        else:
            description += "%s: %s, " % (k, v)
    description = description.rstrip().rstrip(',')
    %>
    <h3 id="header_${underscored_classify}"><a href="#">${section['options']['target']}: ${description}</a></h3>
    <div id="classify_accordion_section_div">
    <div id="${underscored_classify}_form_div">
    <form id="classify_form_${underscored_classify}" class="classify_form_classify" method="post" action="/Network/update_qos">
        <input type="hidden" name="config" value="classify target ${section['options']['target']}" />
        <table id="${underscored_classify}_table" align="center" width="100%">
            <tr>
                <td style="width: 10em;"><label for="${underscored_classify}_delete">${_("Delete")}</label></td>
                <td align="center"><input type="checkbox" id="${underscored_classify}_delete" name="delete" value="${section['options']['target']}" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="${underscored_classify}_options_tr">
            <td style="width: 10em;">
                <select id="${underscored_classify}_options" name="options" title="${_('Select a classify option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['classify'].keys():
            <%
            try:
                # NOTE: Using the option title is just a shortcut until I add
                #       full help texts that are i18n-aware (like classify).
                option_help = plugin_dict['validation_dict']['classify'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-classify ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${underscored_classify}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${underscored_classify}_options_tr").change(function(){
            onSelectChange($("#${underscored_classify}_options option:selected"), $('#${underscored_classify}_table'), '/Network/qos_options_meta', 'classify');
        });
        % for key, value in section['options'].items():
            addField('/Network/qos_options_meta', $('#${underscored_classify}_table'), '${key}', '${value}', 'classify');
        % endfor
        $('#classify_form_${underscored_classify}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['classify'].keys()):
            % if index < len(plugin_dict['validation_dict']['classify'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=classify"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=classify"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
    % endif
% endfor
## New QOS Interface section
    <h3 id="header_new_classify"><a href="#">${_("New QOS Classificiation")}</a></h3>
    <div id="classify_accordion_section_div">
## Easy Buttons
    <div id="easy_buttons_div" class="ui-widget accordion_float_right">
    <h4 class="ui-state-active ui-corner-top ui-widget-header">&nbsp;<strong>${_("Easy Buttons")}</strong></h4>
    <table id="easy_buttons_table" width="100%" align="center">
        <tr>
            <td><button id="prioritize_skype" class="fg-button ui-state-default ui-corner-all">${_("Prioritize Skype")}</button></td>
        </tr>
        <tr>
            <td><button id="prioritize_skypeout" class="fg-button ui-state-default ui-corner-all">${_("Prioritize SkypeOut")}</button></td>
        </tr>
        <tr>
            <td><button id="prioritize_sip" class="fg-button ui-state-default ui-corner-all">${_("Prioritize SIP (VoiP)")}</button></td>
        </tr>
        <tr>
            <td><button id="deprioritize_p2p" class="fg-button ui-state-default ui-corner-all">${_("De-prioritize All P2P")}</button></td>
        </tr>
    </table>
    </div>
    <div id="new_classify_form_div">
    <form id="new_classify_form" class="classify_form_classify" method="post" action="/Network/add_qos_config">
        <input type="hidden" name="config" value="classify" />
        <table id="new_classify_table" align="center">
        </table>
        <table align="center">
        <tr id="new_classify_options_tr">
            <td style="width: 10em;">
                <select id="new_classify_options" name="options" title="${_('Select an classify option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['classify'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['classify'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-classify ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        // Note:  partial() is part of MochiKit.Base
        var addFieldPartial = partial(addField, '/Network/qos_options_meta', $('#new_classify_table'));
        var section = 'classify';
        $('#prioritize_skype').click(function() {
            var d = new Deferred();
            // Remove the 'target' option since we're going to set it and replace it:
            d.addCallback($('#new_classify_table tr:first').remove());
            d.addCallback(addFieldPartial('target', 'Priority', section));
            d.addCallback(addFieldPartial('layer7', 'skypetoskype', section));
            d.addCallback($('#new_classify_options').removeOption('target'));
            d.addCallback($('#new_classify_options').removeOption('layer7'));
            d.addCallback(reloadSelectmenu($('#new_classify_options')));
            d.addCallback(jTipReload());
        });
        $('#prioritize_skypeout').click(function() {
            var d = new Deferred();
            // Remove the 'target' option since we're going to set it and replace it:
            d.addCallback($('#new_classify_table tr:first').remove());
            d.addCallback(addFieldPartial('target', 'Priority', section));
            d.addCallback(addFieldPartial('layer7', 'skypeout', section));
            d.addCallback($('#new_classify_options').removeOption('target'));
            d.addCallback($('#new_classify_options').removeOption('layer7'));
            d.addCallback(reloadSelectmenu($('#new_classify_options')));
            d.addCallback(jTipReload());
        });
        $('#prioritize_sip').click(function() {
            var d = new Deferred();
            d.addCallback($('#new_classify_table tr:first').remove());
            d.addCallback(addFieldPartial('target', 'Priority', section));
            d.addCallback(addFieldPartial('layer7', 'sip', section));
            d.addCallback($('#new_classify_options').removeOption('target'));
            d.addCallback($('#new_classify_options').removeOption('layer7'));
            d.addCallback(reloadSelectmenu($('#new_classify_options')));
            d.addCallback(jTipReload());
        });
        $('#deprioritize_p2p').click(function() {
            var d = new Deferred();
            d.addCallback($('#new_classify_table tr:first').remove());
            d.addCallback(addFieldPartial('target', 'Bulk', section));
            d.addCallback(addFieldPartial('ipp2p', 'all', section));
            d.addCallback($('#new_classify_options').removeOption('target'));
            d.addCallback($('#new_classify_options').removeOption('ipp2p'));
            d.addCallback(reloadSelectmenu($('#new_classify_options')));
            d.addCallback(jTipReload());
        });
        mandatoryField('/Network/qos_options_meta', $('#new_classify_table'), 'target', '', 'classify');
        $('#new_classify_options').removeOption('target');
        $("#new_classify_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#new_classify_options_tr").change(function(){
            onSelectChange($("#new_classify_options option:selected"), $('#new_classify_table'), '/Network/qos_options_meta', 'classify');
        });
        $('#new_classify_form').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['classify'].keys()):
            % if index < len(plugin_dict['validation_dict']['classify'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=classify"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=classify"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
</div>
<script type="text/javascript">
$(document).ready(function(){
    $("#classify_accordion").hide();
    $("#classify_accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#classify_accordion").fadeIn('slow');
        $("#classify_accordion").accordion('activate', 0);
    }, 500);
    $('.classify_form_classify*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {reloadTab($("#classify_accordion"));}, 500);
                    rebootRequired();
                };
            }
        })
    });
    jTipReload();
});
</script>