## -*- coding: utf-8 -*-
<%
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['interface']['list_items']
%>
<div id="accordion">
% for section in plugin_dict['qos_conf'].sections:
    % if 'interface' in section['config']:
    <%
    underscored_interface = section['config'][1].replace('.', '_')
    %>
    <h3 id="header_${underscored_interface}"><a href="#">${section['config'][1]}</a></h3>
    <div id="accordion_section_div">
    <div id="${underscored_interface}_form_div">
    <form id="interface_form_${underscored_interface}" class="interface_form_class" method="post" action="/Network/update_qos">
        <input type="hidden" name="config" value="interface ${section['config'][1]}" />
        <table id="${underscored_interface}_table" align="center" width="100%">
            <tr>
                <td style="width: 10em;">${_("Interface name")}</td><td><input id="${section['config'][1]}" type="text" name="rename" size="18" value="${section['config'][1]}" /></td>
            </tr>
            <tr>
                <td style="width: 10em;"><label for="${underscored_interface}_delete">${_("Delete")}</label></td>
                <td align="center"><input type="checkbox" id="${underscored_interface}_delete" name="delete" value="${section['config'][1]}" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="${underscored_interface}_options_tr">
            <td style="width: 10em;">
                <select id="${underscored_interface}_options" name="options" title="${_('Select a interface option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['interface'].keys():
            <%
            try:
                # NOTE: Using the option title is just a shortcut until I add
                #       full help texts that are i18n-aware (like interface).
                option_help = plugin_dict['validation_dict']['interface'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${underscored_interface}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${underscored_interface}_options_tr").change(function(){
            onSelectChange($("#${underscored_interface}_options option:selected"), $('#${underscored_interface}_table'), '/Network/qos_options_meta', 'interface');
        });
        % for key, value in section['options'].items():
            addField('/Network/qos_options_meta', $('#${underscored_interface}_table'), '${key}', '${value}', 'interface');
        % endfor
        $('#interface_form_${underscored_interface}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['interface'].keys()):
            % if index < len(plugin_dict['validation_dict']['interface'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=interface"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=interface"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
    % endif
% endfor
## New QOS Interface section
    <h3 id="header_new_interface"><a href="#">${_("New QOS Interface Configuration")}</a></h3>
    <div id="accordion_section_div">
## Easy Buttons
    <div id="easy_buttons_div" class="ui-widget accordion_float_right">
    <h4 class="ui-state-active ui-corner-top ui-widget-header">&nbsp;<strong>${_("Easy Buttons")}</strong></h4>
    <table id="easy_buttons_table" width="100%" align="center">
        <tr>
            <td><button id="basic_tcp_forward" title="Configures a generic QOS interface (to save time)." class="fg-button ui-state-default ui-corner-all">${_("Standard QOS Options")}</button></td>
        </tr>
        <tr>
            <td><button id="comcast_powerboost" title="Configures a new WAN interface for Comcast's Powerboost (10 megabytes of download bursting at double your regular speed)." class="fg-button ui-state-default ui-corner-all">${_("Comcast Powerboost")}</button></td>
        </tr>
    </table>
    </div>
    <div id="new_interface_form_div">
    <form id="new_interface_form" class="interface_form_class" method="post" action="/Network/add_qos_config">
        <input type="hidden" name="config" value="interface" />
        <table id="new_interface_table" align="center">
            <tr>
                <td style="width: 10em;">${_("Interface name")}</td><td><input id="new_interface_name" type="text" name="config" size="18" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="new_interface_options_tr">
            <td style="width: 10em;">
                <select id="new_interface_options" name="options" title="${_('Select an interface option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['interface'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['interface'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#new_interface_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#new_interface_options_tr").change(function(){
            onSelectChange($("#new_interface_options option:selected"), $('#new_interface_table'), '/Network/qos_options_meta', 'interface');
        });
    });
    </script>
</div>
<script type="text/javascript">
$(document).ready(function(){
    // Note:  partial() is part of MochiKit.Base
    var addFieldPartial = partial(addField, '/Network/qos_options_meta', $('#new_interface_table'));
    var section = 'interface';
    $('#basic_tcp_forward').click(function() {
        var d = new Deferred();
        d.addCallback(addFieldPartial('classgroup', 'Default', section));
        d.addCallback(addFieldPartial('overhead', '1', section));
        d.addCallback(addFieldPartial('download', '', section));
        d.addCallback(addFieldPartial('upload', '', section));
        d.addCallback(addFieldPartial('enabled', '1', section));
        d.addCallback(jTipReload());
    });
    // Powerboost settings taken from here: https://dev.openwrt.org/ticket/1618
    $('#comcast_powerboost').click(function() {
        download_val = parseInt($('#wan_form_div [name=download]').val());
        upload_val = parseInt($('#wan_form_div [name=upload]').val());
        $('#new_interface_name').val('wan_boosted');
        var d = new Deferred();
        d.addCallback(addFieldPartial('classgroup', 'Default', section));
        d.addCallback(addFieldPartial('overhead', '1', section));
        d.addCallback(addFieldPartial('download', download_val*2, section));
        d.addCallback(addFieldPartial('upload', upload_val, section));
        d.addCallback(addFieldPartial('enabled', '1', section));
        d.addCallback(addFieldPartial('connbytes', '0-9437184', section));
        d.addCallback(jTipReload());
        d.addCallback($('#result').html("<div class='ui-state-highlight'><span id='close_this' class='ui-icon ui-icon-closethick' style='float: right; cursor: pointer;' onclick='$(this).parent().parent().hide();clearTimeout(resultTimeout);return false;'></span><span class='ui-icon ui-icon-check ui-icon-left' style='margin-right: .3em;'></span> Don't forget to set connbytes to '9437184-' on the 'wan' interface!  (That number is in the help)</div>"));
        d.addCallback(showResult());
    });
    $("#accordion").hide();
    $("#accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#accordion").fadeIn('slow');
        $("#accordion").accordion('activate', 0);
    }, 500);
    $('.interface_form_class*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {reloadTab($("#accordion"));}, 500);
                    rebootRequired();
                };
            }
        })
    });
    $('#new_interface_form').validate({
        errorPlacement: function(error, element) {
            error.appendTo(element.parent("td").next("td"));
        },
        focusCleanup: true,
        rules: {
    % for index, option in enumerate(plugin_dict['validation_dict']['interface'].keys()):
        % if index < len(plugin_dict['validation_dict']['interface'].keys()) - 1:
            ${option}: {
                required: true,
                remote: "/Network/validate_option?config=qos&section=interface"
            },
        % else:
            ${option}: {
                required: true,
                remote: "/Network/validate_option?config=qos&section=interface"
            }
        % endif
    % endfor
        }
    });
    jTipReload();
});
</script>