## -*- coding: utf-8 -*-
<%
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['reclassify']['list_items']
count = 0 # This is because we'll have multiple tables with the same name
%>
<div id="reclassify_accordion">
% for section in plugin_dict['qos_conf'].sections:
    % if 'reclassify' in section['config']:
    <%
    count += 1
    underscored_reclassify = section['options']['target'].replace('.', '_') + str(count)
    description = ""
    for k, v in section['options'].items():
        if k == 'target':
            pass
        else:
            description += "%s: %s, " % (k, v)
    description = description.rstrip().rstrip(',')
    %>
    <h3 id="header_${underscored_reclassify}"><a href="#">${section['options']['target']}: ${description}</a></h3>
    <div id="reclassify_accordion_section_div">
    <div id="${underscored_reclassify}_form_div">
    <form id="reclassify_form_${underscored_reclassify}" class="reclassify_form_reclassify" method="post" action="/Network/update_qos">
        <input type="hidden" name="config" value="reclassify target ${section['options']['target']}" />
        <table id="${underscored_reclassify}_table" align="center" width="100%">
            <tr>
                <td style="width: 10em;"><label for="${underscored_reclassify}_delete">${_("Delete")}</label></td>
                <td align="center"><input type="checkbox" id="${underscored_reclassify}_delete" name="delete" value="${section['options']['target']}" /></td>
            </tr>
        </table>
        <table align="center">
        <tr id="${underscored_reclassify}_options_tr">
            <td style="width: 10em;">
                <select id="${underscored_reclassify}_options" name="options" title="${_('Select a reclassify option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['reclassify'].keys():
            <%
            try:
                # NOTE: Using the option title is just a shortcut until I add
                #       full help texts that are i18n-aware (like reclassify).
                option_help = plugin_dict['validation_dict']['reclassify'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-reclassify ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${underscored_reclassify}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${underscored_reclassify}_options_tr").change(function(){
            onSelectChange($("#${underscored_reclassify}_options option:selected"), $('#${underscored_reclassify}_table'), '/Network/qos_options_meta', 'reclassify');
        });
        % for key, value in section['options'].items():
            addField('/Network/qos_options_meta', $('#${underscored_reclassify}_table'), '${key}', '${value}', 'reclassify');
        % endfor
        $('#reclassify_form_${underscored_reclassify}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['reclassify'].keys()):
            % if index < len(plugin_dict['validation_dict']['reclassify'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=reclassify"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=qos&section=reclassify"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
    % endif
% endfor
## New QOS Reclassify section
    <h3 id="header_new_reclassify"><a href="#">${_("New QOS Re-Classificiation")}</a></h3>
    <div id="reclassify_accordion_section_div">
    <div id="new_reclassify_form_div">
    <form id="new_reclassify_form" class="reclassify_form_reclassify" method="post" action="/Network/add_qos_config">
        <input type="hidden" name="config" value="reclassify" />
        <table id="new_reclassify_table" align="center">
        </table>
        <table align="center">
        <tr id="new_reclassify_options_tr">
            <td style="width: 10em;">
                <select id="new_reclassify_options" name="options" title="${_('Select an reclassify option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['reclassify'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['reclassify'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 13.5em; text-align: right;"><button class="fg-button ui-state-reclassify ui-corner-all" type="submit">${_("Submit")}</button></td>
        </tr>
        </table>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        mandatoryField('/Network/qos_options_meta', $('#new_reclassify_table'), 'target', '', 'reclassify');
        $('#new_reclassify_options').removeOption('target');
        $("#new_reclassify_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#new_reclassify_options_tr").change(function(){
            onSelectChange($("#new_reclassify_options option:selected"), $('#new_reclassify_table'), '/Network/qos_options_meta', 'reclassify');
        });
    });
    </script>
</div>
<script type="text/javascript">
$(document).ready(function(){
    $("#reclassify_accordion").hide();
    $("#reclassify_accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#reclassify_accordion").fadeIn('slow');
        $("#reclassify_accordion").accordion('activate', 0);
    }, 500);
    $('.reclassify_form_reclassify*').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {reloadTab($("#reclassify_accordion"));}, 500);
                    rebootRequired();
                };
            }
        })
    });
    $('#new_reclassify_form').validate({
        errorPlacement: function(error, element) {
            error.appendTo(element.parent("td").next("td"));
        },
        focusCleanup: true,
        rules: {
    % for index, option in enumerate(plugin_dict['validation_dict']['reclassify'].keys()):
        % if index < len(plugin_dict['validation_dict']['reclassify'].keys()) - 1:
            ${option}: {
                required: true,
                remote: "/Network/validate_option?config=qos&section=reclassify"
            },
        % else:
            ${option}: {
                required: true,
                remote: "/Network/validate_option?config=qos&section=reclassify"
            }
        % endif
    % endfor
        }
    });
    jTipReload();
});
</script>