<%
# This is used to generate unique IDs for jtip
from random import Random
rand = Random()
%>
<style type="text/css">
    .sortable { list-style-type: none; margin: 0; padding: 0; width: 52em; }
    .sortable li { margin: 0 0 2px 2px; padding-left: 0.5em;}
    .sortable li span { position: absolute; margin-left: -1.3em; }
</style>
<strong>Select the Quagga configuration file you wish to edit:</strong>
<div id="accordion">
% for config_file in plugin_dict['config_files']:
    <%
    underscored_path = config_file.filepath.lstrip('/').replace('/', '_').rstrip('.conf')
    %>
    <h3 id="header_${underscored_path}"><a href="#">${config_file.filepath}</a></h3>
    <div id="accordion_section_div">
    <div id="${underscored_path}_form_div">
    <button id="${underscored_path}_raw" class="ui-pg-button ui-state-default ui-corner-all">${_("Edit %s directly") % config_file.filepath}</button><br /><br />
    <form id="${underscored_path}_form" class="${underscored_path}_form_class" method="post" action="/Services/update_quagga_config">
        <input type="hidden" name="filepath" value="${config_file.filepath}" />
## This hidden 'config' input is filled out when the form is submitted...
        <input type="hidden" name="config" value="" />
        <ul id="sortable_${underscored_path}" class="sortable">
        % for key, value in config_file.config:
            <%
            if key == 'comment':
                line_key = '!'
            else:
                line_key = key
            %>
            <li class="ui-widget-content">
            <table><tr valign="middle"><td style="width: 10em;">
            <a href="/Services/quagga_options_meta?width=475&filepath=${config_file.filepath}&option=${key}" id="${underscored_path}_${rand.randint(1,9999)}_${key}" class="jTip" name="Option Help">${key}</a></td><td><input type="text" id="${key}" name="${key}" size="60" value="${line_key} ${value}" /></td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id="remove_option" class="ui-icon ui-icon-closethick" style="cursor: pointer; display: inline;" onclick="$(this).parent().parent().parent().parent().parent().remove();return false;" /></td></tr></table>
            </li>
        % endfor
        </ul>
        <table align="center">
        <tr id="${underscored_path}_options_tr">
            <td style="width: 10em;">
                <select id="${underscored_path}_options" name="options" title="${_('Select an ${underscored_path} option')}">
                <option value="">${_("Add option...")}</option>
        % for option in config_file.valid_commands():
            <%
            try:
                option_help = plugin_dict['validation_dict']['${underscored_path}'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
                </select>
            </td>
            <td style="width: 10.5em; text-align: right;">
            <button id="${underscored_path}_submit" class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button>
            </td>
        </tr>
        </table>
    </form>
    </div>
    <div id="${underscored_path}_raw_div">
    <form id="${underscored_path}_raw_form" class="${underscored_path}_form_class" method="post" action="/Services/update_quagga_config">
        <input type="hidden" name="filepath" value="${config_file.filepath}" />
        <p><textarea name="config" id="raw_config" rows="20" cols="80" class="code"></textarea></p>
        <p><button id="${underscored_path}_raw_cancel" class="fg-button ui-state-default ui-corner-all">${_("Cancel")}</button><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></p>
    </form>
    </div>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $('#${underscored_path}_raw_div').hide();
        $('#${underscored_path}_raw').hover(function() {
            $(this).addClass('ui-state-hover');
        }, function() {
            $(this).removeClass('ui-state-hover');
        });
        $('#${underscored_path}_raw').click(function() {
            $('#${underscored_path}_form_div').fadeOut('slow', function() {
                // Fill out the raw form textarea before we switch to it
                formObjects = $('#${underscored_path}_form').formToArray();
                forEach(formObjects, objValueToConfig_${underscored_path});
                $('#${underscored_path}_raw_div').fadeIn('slow');
            });
        });
        $('#${underscored_path}_raw_cancel').click(function() {
            $('#${underscored_path}_raw_div').fadeOut('slow', function() {
                $('#${underscored_path}_form_div').fadeIn('slow')
            });
            return false;
        });
        $("#sortable_${underscored_path}").sortable();
        $("#sortable_${underscored_path}").disableSelection();
        $("#accordion").accordion({ collapsible: true, autoHeight: false, active: false });
        $("#${underscored_path}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${underscored_path}_options").change(function(){
            onSelectChangeQuagga($("#${underscored_path}_options option:selected"), $('#sortable_${underscored_path}'), '/Services/quagga_options_meta', '${config_file.filepath}');
        });
        // TODO:  I need to think about how I'm going to do validation for Quagga files.
//         $('#${underscored_path}_form_${underscored_path}').validate({
//             errorPlacement: function(error, element) {
//                 error.appendTo(element.parent("td").next("td"));
//             },
//             focusCleanup: true,
//             rules: {
//         % for option in plugin_dict['validation_dict']['zebra'].keys():
//                 ${option}: {
//                     remote: "/Services/validate_option?config=${underscored_path}&section=${underscored_path}"
//                 },
//         % endfor
//             }
//         });
        function objValueToConfig_${underscored_path}(inputObj) {
            // Meant to be run with MochiKit's forEach()...
            //    Checks if inputObj.value should be part of the output.  If so, appends it to #config
            if (inputObj.name == 'filepath') {
                noop(); // Don't append it
            } else if (inputObj.name == 'config') {
                noop();
            } else if (inputObj.name == 'options') {
                noop();
            } else {
                // Append each line (in order) to both the hidden and raw 'config' input elements
                currentVal = $('#${underscored_path}_form input[name=config]').val();
                $('#${underscored_path}_form input[name=config]').val(currentVal + inputObj.value + '\n');
                $('#${underscored_path}_raw_form textarea[name=config]').val(currentVal + inputObj.value + '\n');
            }
            return false;
        };
        $('#${underscored_path}_form').ajaxForm({
            target: '#result',
            beforeSerialize: function(formObj) {
                // This function uses forEach() to take all input elements and put them in #config as if it were a textarea/raw edit form
                formObjects = $('#${underscored_path}_form').formToArray();
                forEach(formObjects, objValueToConfig_${underscored_path});
            },
            success: function() {
                showResult();
                // Reload the tab to make sure everything gets loaded with the new changes
                reloadTab($("#accordion"));
            }
        });
        $('#${underscored_path}_raw_form').ajaxForm({
            target: '#result',
            success: function() {
                showResult();
                // Reload the tab to make sure everything gets loaded with the new changes
                reloadTab($("#accordion"));
            }
        });
        jTipReload();
    });
    </script>
%endfor
</div>
<script type="text/javascript">
function onSelectChangeQuagga(selectedObject, ol, helpURL, filepath){
    // selectedObject: The option that was selected in the options list
    // os: The <ol> to append the new list item
    // helpURL: The base URL to use when looking up help for this option (i.e. /Network/interface_options)
    // filepath: The path to the related config file.
    var output = "";
    var option = selectedObject.val();
    var valuesURL = helpURL + '?option=' + option + '&filepath=' + filepath;
    // This is to ensure that each jTip gets a unique ID (otherwise it gets confused in jquery-ui tabs)
    var randomnumber = Math.floor(Math.random()*1000);
    if (selectedObject.val() != 0){
        output = '<li class="ui-widget-content"><table><tr><td style="width: 10em;"><a href="' + helpURL + '?width=475&option=' + option + '&filepath=' + filepath + '" id="' + option + '_jtip" class="jTip" name="Option Help">' + option + '</a></td><td><input type="text" id="' + option + '" name="' + option + '" size="60" value="' + option + ' " /></td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id="remove_option" class="ui-icon ui-icon-closethick" style="cursor: pointer; display: inline;" onclick="$(this).parent().parent().parent().parent().parent().remove();return false;" /></td></tr></table></li>';
        ol.append(output);
    };
    jTipReload();
}
</script>