## -*- coding: utf-8 -*-
<%
# This just keep these list items out of the pulldown menus
del plugin_dict['validation_dict']['wifi-device']['list_items']
del plugin_dict['validation_dict']['wifi-iface']['list_items']
%>
<script type="text/javascript">
orderlyLoad = new Deferred(); // Used to prevent wifi-iface elements from loading along with or before wifi-device elements (speeds up loading and keeps the accordion size sane)
function oc(a) {
    // Got this from http://snook.ca/archives/javascript/testing_for_a_v/ (thanks Jonathan Snook!)
    // This allows me to do "for (a in oc(<array>))...
    // just like in Python
    var o = {};
    for(var i=0;i<a.length;i++)
    {
        o[a[i]]='';
    }
    return o;
};
function channelCheck(wirelessDevice){
    var url = "/Network/wireless_channel_check";
    var d = loadJSONDoc(url, {device: wirelessDevice});
    var thisFormRename = null;
    var gotMetadata = function (meta) {
        $('.wireless_form_class_device').each(function() {
            thisFormRename = $('#' + this.id + ' input[name=rename]').val();
            $('#' + this.id + ' select :contains("Channel")').each(function() {
                if (thisFormRename == wirelessDevice) {
                    if (this.value in oc(meta)) {
                        noop(); // Do nothing
                    } else {
                        $(this).parent().removeOption(this.value);
                    }
                }
            });
            var e = new Deferred(); // So they execute in order
            e.addCallback($('#' + this.id + ' select :contains("Channel")').parent().selectmenu('destroy'));
            e.addCallback($('#' + this.id + ' select :contains("Channel")').parent().selectmenu({
                width: 120,
                menuWidth: 500,
                maxHeight: 300,
                format: optionHelpFormatting
            }));
        });
    };
    d.addCallback(gotMetadata);
};
</script>
% if plugin_dict['wireless_conf'].sections:
<div id="accordion">
% for section in plugin_dict['wireless_conf'].sections:
    <%
    device_name = ""
    for key, value in section['options'].iteritems():
        if key == "device":
            device_name = value # This will be the name of the wifi-iface (since it isn't in the 'config' section of /etc/conf/wireless)
    # The below line formats the config + device name into a string free of whitespace and hyphens
    # ...since you can't have spaces inside of "id" and because JavaScript doesn't like function names and variables with hyphens in them
    underscored_config = "_".join("_".join(section['config']).split('-'))
    joined_config = " ".join(section['config'])
    %>
    % if 'wifi-device' in section['config']:
## wifi-device section
    <h3 id="header_${underscored_config}"><a href="#">${joined_config} (Physical Device)</a></h3>
    <div id="accordion_section_div">
    <div id="wireless_device_div">
    <form id="wireless_form_${underscored_config}" class="wireless_form_class_device" method="post" action="/Network/update_wireless">
        <input type="hidden" name="config" value="${joined_config}">
        <table id="${underscored_config}_table" align="center">
        <tr>
            <td style="width: 10em;">${_("Name")}</td><td><input id="${underscored_config}" type="text" name="rename" size="18" value="${section['config'][1]}" /></td>
        </tr>
        <tr>
            <td style="width: 10em;"><label for="${underscored_config}_delete">${_("Delete")}</label></td>
            <td align="center"><input type="checkbox" id="${underscored_config}_delete" name="delete" value="${joined_config} ${device_name}" /></td>
        </tr>
        </table>
        <table align="center">
        <tr id="select_option">
            <td style="width: 10em;">
            <select id="${section['config'][1]}_options" name="options" title="${_('Select a wireless interface option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['wifi-device'].keys():
            <%
            try:
                option_help = plugin_dict['wifi_device_options'][option]['help']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
            </select>
            </td>
            <td style="width: 14.3em; text-align: right;">
                <button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button>
            </td>
        </tr>
        </table>
    </form>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        // This line removes channels that don't apply to this interface:
        setTimeout(function() {channelCheck('${section['config'][1]}')}, 1500);
        $("#${section['config'][1]}_options").removeOption('type')
        $("#${section['config'][1]}_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${section['config'][1]}_options").change(function(){
            onSelectChange($("#${section['config'][1]}_options option:selected"), $('#${underscored_config}_table'), '/Network/wireless_options_meta', 'wifi-device');
        });
        % for key, value in section['options'].items():
        orderlyLoad.addCallback(addField('/Network/wireless_options_meta', $('#${underscored_config}_table'), '${key}', '${value}', 'wifi-device'));
        % endfor
        $('#wireless_form_${underscored_config}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['wifi-device'].keys()):
            % if index < len(plugin_dict['validation_dict']['wifi-device'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=wireless&section=wifi-device"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=wireless&section=wifi-device"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
    % elif 'wifi-iface' in section['config']:
## wifi-iface section
    <div id="${section['options']['device']}_wifi_iface_accordion" class="wifi_iface_accordion_class">
    <h3 id="header_${underscored_config}"><a href="#">wifi-iface ${section['options']['device']} (Virtual Interface)</a></h3>
    <div>
    <form id="wireless_form_${underscored_config}" class="wireless_form_class" method="post" action="/Network/update_wireless">
        <input type="hidden" name="config" value="${joined_config}">
        <table id="${underscored_config}_table" align="center">
        <tr>
            <td style="width: 10em;"><label for="${underscored_config}_delete">${_("Delete")}</label></td>
            <td align="center"><input type="checkbox" id="${underscored_config}_delete" name="delete" value="${section['options']['device']}" /></td>
        </tr>
        </table>
        <table align="center">
        <tr id="select_option">
            <td style="width: 10em;">
            <select id="${section['options']['device']}_wifi_iface_options" name="wifi_iface_options" title="${_('Select a wireless interface option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['wifi-iface'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['wifi-iface'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
            </select>
            </td>
            <td style="width: 14.3em; text-align: right;">
                <button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button>
            </td>
        </tr>
        </table>

    </form>
    </div>
    <script type="text/javascript">
    $(document).ready(function(){
        $("#${section['options']['device']}_wifi_iface_options").selectmenu({
            width: 120,
            menuWidth: 500,
            maxHeight: 300,
            format: optionHelpFormatting
        });
        $("#${section['options']['device']}_wifi_iface_options").change(function(){
            onSelectChange($("#${section['options']['device']}_wifi_iface_options option:selected"), $('#${underscored_config}_table'), '/Network/wireless_options_meta', 'wifi-iface');
        });
    % for key, value in section['options'].items():
        orderlyLoad.addCallback(addField('/Network/wireless_options_meta', $('#${underscored_config}_table'), '${key}', '${value}', 'wifi-iface'));
    % endfor
        orderlyLoad.setFinalizer($("#${section['options']['device']}_wifi_iface_accordion").accordion({ collapsible: true, autoHeight: false }));
        $('#wireless_form_${underscored_config}').validate({
            errorPlacement: function(error, element) {
                error.appendTo(element.parent("td").next("td"));
            },
            focusCleanup: true,
            rules: {
        % for index, option in enumerate(plugin_dict['validation_dict']['wifi-iface'].keys()):
            % if index < len(plugin_dict['validation_dict']['wifi-iface'].keys()) - 1:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=wireless&section=wifi-iface"
                },
            % else:
                ${option}: {
                    required: true,
                    remote: "/Network/validate_option?config=wireless&section=wifi-iface"
                }
            % endif
        % endfor
            }
        });
    });
    </script>
    </div>
    <p><button id="${section['options']['device']}_add_wifi_iface_button" class="fg-button ui-state-default ui-corner-all wifi_iface_button">Add Virtual Wireless Interface</button></p>
    % endif
% endfor
</div>
</div>
% else:
    <p>${_("There are no wireless interfaces or devices configured in /etc/config/wireless.")}</p>
% endif
<div id="new_wifi_iface">
    <form id="new_wifi_iface_form" class="wifi_iface_form_class option_select_list" method="post" action="/Network/add_wireless_interface">
    <table align="center" id="new_wifi_iface_table">
    </table>
    <table id="new_wifi_iface_table2" align="center">
        <tr id="select_wifi_iface_option">
            <td style="width: 10em;">
            <select id="wifi_iface_options" name="options" title="${_('Select an wifi-iface option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['wifi-iface'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['wifi-iface'][option]['title']
                ##option_help = plugin_dict['option_help'][option]['help']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
            </select>
            </td>
            <td style="width: 13.6em; text-align: right;">
                <button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button>
            </td>
        </tr>
    </table>
    </form>
</div>
<script type="text/javascript">
$(document).ready(function(){
    $('#new_wifi_iface').hide();
    % if plugin_dict['wireless_conf'].sections:
    $("#accordion").hide();
    $("#accordion").accordion({ collapsible: true, active: false, autoHeight: false });
    setTimeout(function() {
        $("#accordion").fadeIn('slow');
        $("#accordion").accordion('activate', 0);
//         $(".wifi_iface_accordion_class").each(function(n) {
//             $(this).accordion({ collapsible: true, autoHeight: true });
//         });
    }, 500);
    % endif
    $('.wireless_form_class_device').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                // Note: contains() is from MochiKit.Text
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {
                        reloadTab($("#accordion"));
                        rebootRequired();
                    }, 500);
                };
            }
        })
    });
    $('.wireless_form_class').each(function(n) {
        $(this).ajaxForm({
            target: '#result',
            success: function(responseText) {
                showResult();
                if (contains(_("<strong>Success:</strong>"), responseText)) {
                    setTimeout(function() {
                        reloadTab($("#accordion"));
                        rebootRequired();
                    }, 500);
                };
            }
        })
    });
    var lastval;
    $("input[name='rename']").focus(function () {
        lastval = $(this).attr('value');
    });
    $("input[name='rename']").blur(function () { // This just changes the header to match the value of the interface name if the user changes it
        thisHeaderID = '#header_' + $(this).attr('id');
        var replacement = "wifi-device " + $(this).attr('value');
        $(thisHeaderID + " a").html(replacement);
    });
    // This enables the "Add Virtual Wireless Interface" button...
    $('.wifi_iface_button').each(function(n) {
        $(this).click(function() {
            count = count + 1;
            var interface = this.id.split('_')[0];
            var thisSection = '#' + interface + '_wifi_iface_accordion';
            var parentAccordion = $('#' + interface + '_wifi_iface_accordion');
//             var activeAccordion = parentAccordion.accordion('option', 'active');
            $('<h3 id="header_new_wifi_iface' + count + '"><a href="#">New Virtual Wireless Interface</a></h3>').appendTo(parentAccordion);
            $('#new_wifi_iface').appendTo(parentAccordion);
            parentAccordion.accordion('destroy');
            var d = new Deferred(); // So they execute in order
            d.addCallback(mandatoryField('/Network/wireless_options_meta', $('#new_wifi_iface_table'), 'ssid', '', 'wifi-iface'));
            d.addCallback($("#wifi_iface_options").removeOption('ssid'));
            d.addCallback(mandatoryField('/Network/wireless_options_meta', $('#new_wifi_iface_table'), 'device', interface, 'wifi-iface'));
            d.addCallback($("#wifi_iface_options").removeOption('device'));
            d.addCallback(mandatoryField('/Network/wireless_options_meta', $('#new_wifi_iface_table'), 'network', '', 'wifi-iface'));
            d.addCallback($("#wifi_iface_options").removeOption('network'));
            d.addCallback(mandatoryField('/Network/wireless_options_meta', $('#new_wifi_iface_table'), 'mode', '', 'wifi-iface'));
            d.addCallback($("#wifi_iface_options").removeOption('mode'));
            d.addCallback($("#wifi_iface_options").selectmenu({
                    width: 120,
                    menuWidth: 500,
                    maxHeight: 300,
                    format: optionHelpFormatting
                }));
            parentAccordion.accordion({ collapsible: true, autoHeight: false, active: false});
            setTimeout(function() {
                parentAccordion.accordion('activate', ':last');
                parentAccordion.accordion('resize');
                jTipReload();
            }, 500);
        });
    });
    $("#wifi_iface_options").change(function(){
        onSelectChange($("#wifi_iface_options option:selected"), $('#new_wifi_iface_table'), '/Network/wireless_options_meta', 'wifi-iface');
    });
    $('#new_wifi_iface_form').validate({
        errorPlacement: function(error, element) {
            error.appendTo(element.parent("td").next("td"));
        },
        focusCleanup: true,
        rules: {
    % for index, option in enumerate(plugin_dict['validation_dict']['wifi-iface'].keys()):
        % if index < len(plugin_dict['validation_dict']['wifi-iface'].keys()) - 1:
            ${option}: {
                required: true,
                remote: "/Network/validate_option?config=wireless&section=wifi-iface"
            },
        % else:
            ${option}: {
                required: true,
                remote: "/Network/validate_option?config=wireless&section=wifi-iface"
            }
        % endif
    % endfor
        }
    });
    jTipReload(); //Initialize jTip for great tooltips
});
</script>