## -*- coding: utf-8 -*-
<p><i>${_("<strong>Note:</strong> When OpenWRT boots with a new wireless card it will auto-create a configuration for it in /etc/config/wireless.  In other words, you probably don't want to use this form unless you really know what you're doing.")}</i></p>
## Easy Buttons
<div id="easy_buttons_div" class="ui-widget accordion_float_right">
<h4 class="ui-state-active ui-corner-top ui-widget-header">&nbsp;<strong>${_("Easy Buttons")}</strong></h4>
<table id="easy_buttons_table" width="100%" align="center">
    <tr>
        <td><button id="standard_options" class="fg-button ui-state-default ui-corner-all">${_("Standard Options")}</button></td>
    </tr>
</table>
</div>

<form id="new_wireless_device_form" method="post" action="/Network/add_wireless_device">
<table id="new_wireless_device_table" align="center">
    <tr>
        <td style="width: 10em;">${_("Device Name")}</td>
        <td><input type="text" name="config" size="18" /></td>
    </tr>
</table>
<table align="center">
    <tr id="select_wireless_device_option">
        <td style="width: 10em;">
            <select id="wireless_device_options" name="options" title="${_('Select a wireless device option')}">
                <option value="">${_("Add option...")}</option>
        % for option in plugin_dict['validation_dict']['wifi-device'].keys():
            <%
            try:
                option_help = plugin_dict['validation_dict']['wifi-device'][option]['title']
            except:
                option_help = _("No help text available")
            %>
                <option value="${option}">${option} - ${option_help}</option>
        % endfor
            </select>
        </td>
    </tr>
    <tr>
        <td><button class="fg-button ui-state-default ui-corner-all" type="submit">${_("Submit")}</button></td>
    </tr>
</table>
</form>
<script type="text/javascript">
$(document).ready(function(){
    var d = new Deferred();
    $('#new_wireless_device_form').ajaxForm({
        target: '#result',
        success: function() {
            showResult();
            if (contains(_("<strong>Success:</strong>"), responseText)) {
                setTimeout(function() {
                    rebootRequired();
                }, 500);
            };
        }
    });
    // Note:  partial() is part of MochiKit.Base
    var addFieldPartial = partial(addField, '/Network/wireless_options_meta', $('#new_wireless_device_table'));
    var section = 'wifi-device';
    $('#standard_options').click(function() {
        addFieldPartial('disabled', '0', section);
        addFieldPartial('type', '', section);
        addFieldPartial('channel', '1', section);
        jTipReload();
    });
    $("#select_wireless_device_option").change(function(){
        onSelectChange($("#wireless_device_options option:selected"), $('#new_wireless_device_table'), '/Network/wireless_options_meta', 'wifi-device');
    });
    d.addCallback(mandatoryField('/Network/wireless_options_meta', $('#new_wifi_iface_table'), 'type', '', 'wifi-device'));
    d.addCallback($("#wireless_device_options").removeOption('type'));
    d.addCallback($("#wireless_device_options").selectmenu({
        width: 120,
        menuWidth: 500,
        maxHeight: 300,
        format: optionHelpFormatting
    }));
    $('#new_wireless_device_form').validate({
        errorPlacement: function(error, element) {
            error.appendTo(element.parent("td").next("td"));
        },
        focusCleanup: true,
        rules: {
    % for index, option in enumerate(plugin_dict['validation_dict']['wifi-device'].keys()):
        % if index < len(plugin_dict['validation_dict']['wifi-device'].keys()) - 1:
            ${option}: {
                required: true,
                remote: "/Network/validate_option?config=wireless&section=wifi-device"
            },
        % else:
            ${option}: {
                required: true,
                remote: "/Network/validate_option?config=wireless&section=wifi-device"
            }
        % endif
    % endfor
        }
    });
    jTipReload(); //Initialize jTip for great tooltips
});
</script>